=== modified file '.bzrignore'
--- .bzrignore	2010-09-30 06:24:20 +0000
+++ .bzrignore	2008-10-03 09:32:30 +0000
@@ -2,6 +2,8 @@
 *.8
 *.8mandos
 confdir
+debian/po/messages.mo
+debian/po/templates.pot
 keydir
 man
 plugin-runner
@@ -10,4 +12,3 @@
 plugins.d/password-prompt
 plugins.d/splashy
 plugins.d/usplash
-plugins.d/plymouth

=== modified file 'DBUS-API'
--- DBUS-API	2010-09-26 18:32:58 +0000
+++ DBUS-API	2010-09-12 03:00:40 +0000
@@ -76,26 +76,25 @@
    "clients.conf", in which case they are fully documented in
    mandos-clients.conf(5).
    
-   | Name                    | Type | Access     | clients.conf        |
-   |-------------------------+------+------------+---------------------|
-   | ApprovedByDefault       | b    | Read/Write | approved_by_default |
-   | ApprovalDelay (a)       | t    | Read/Write | approval_delay      |
-   | ApprovalDuration (a)    | t    | Read/Write | approval_duration   |
-   | ApprovalPending (b)     | b    | Read       | N/A                 |
-   | Checker                 | s    | Read/Write | checker             |
-   | CheckerRunning (c)      | b    | Read/Write | N/A                 |
-   | Created (d)             | s    | Read       | N/A                 |
-   | Enabled (e)             | b    | Read/Write | N/A                 |
-   | Fingerprint             | s    | Read       | fingerprint         |
-   | Host                    | s    | Read/Write | host                |
-   | Interval (a)            | t    | Read/Write | interval            |
-   | LastApprovalRequest (f) | s    | Read       | N/A                 |
-   | LastCheckedOK (g)       | s    | Read/Write | N/A                 |
-   | LastEnabled (h)         | s    | Read       | N/A                 |
-   | Name                    | s    | Read       | (Section name)      |
-   | ObjectPath              | o    | Read       | N/A                 |
-   | Secret (i)              | ay   | Write      | secret (or secfile) |
-   | Timeout (a)             | t    | Read/Write | timeout             |
+   | Name                 | Type | Access     | clients.conf        |
+   |----------------------+------+------------+---------------------|
+   | ApprovedByDefault    | b    | Read/Write | approved_by_default |
+   | ApprovalDelay (a)    | t    | Read/Write | approval_delay      |
+   | ApprovalDuration (a) | t    | Read/Write | approval_duration   |
+   | ApprovalPending (b)  | b    | Read       | N/A                 |
+   | Checker              | s    | Read/Write | checker             |
+   | CheckerRunning (c)   | b    | Read/Write | N/A                 |
+   | Created (d)          | s    | Read       | N/A                 |
+   | Enabled (e)          | b    | Read/Write | N/A                 |
+   | Fingerprint          | s    | Read       | fingerprint         |
+   | Host                 | s    | Read/Write | host                |
+   | Interval (a)         | t    | Read/Write | interval            |
+   | LastCheckedOK (f)    | s    | Read/Write | N/A                 |
+   | LastEnabled (g)      | s    | Read       | N/A                 |
+   | Name                 | s    | Read       | (Section name)      |
+   | ObjectPath           | o    | Read       | N/A                 |
+   | Secret (h)           | ay   | Write      | secret (or secfile) |
+   | Timeout (a)          | t    | Read/Write | timeout             |
    
    a) Represented as milliseconds.
    
@@ -109,20 +108,17 @@
    e) Setting this property is equivalent to calling Enable() or
       Disable().
    
-   f) The time of the last approval request, as a RFC 3339 string, or
-      an empty string if this has not happened.
-   
-   g) The last time a checker was successful, as a RFC 3339 string, or
+   f) The last time a checker was successful, as a RFC 3339 string, or
       an empty string if this has not happened.  Setting this property
       is equivalent to calling CheckedOK(), i.e. the current time is
       set, regardless of the string sent.  Please always use an empty
       string when setting this property, to allow for possible future
       expansion.
    
-   h) The last time this client was enabled, as a RFC 3339 string, or
+   g) The last time this client was enabled, as a RFC 3339 string, or
       an empty string if this has not happened.
    
-   i) A raw byte array, not hexadecimal digits.
+   h) A raw byte array, not hexadecimal digits.
 
 ** Signals
 *** CheckerCompleted(n: Exitcode, x: Waitstatus, s: Command)
@@ -147,26 +143,5 @@
 *** Rejected(s: Reason)
     This client was not given its secret for a specified Reason.
 
-* Copyright
-
-    Copyright © 2010 Teddy Hogeborn
-    Copyright © 2010 Björn Påhlsson
-  
-** License:
-   
-   This program is free software: you can redistribute it and/or
-   modify it under the terms of the GNU General Public License as
-   published by the Free Software Foundation, either version 3 of the
-   License, or (at your option) any later version.
-
-   This program is distributed in the hope that it will be useful, but
-   WITHOUT ANY WARRANTY; without even the implied warranty of
-   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
-   General Public License for more details.
-
-   You should have received a copy of the GNU General Public License
-   along with this program.  If not, see
-   <http://www.gnu.org/licenses/>.
-
 
 #+STARTUP: showall

=== modified file 'Makefile'
--- Makefile	2010-10-02 17:23:41 +0000
+++ Makefile	2010-09-14 18:22:03 +0000
@@ -23,7 +23,7 @@
 OPTIMIZE=-Os
 LANGUAGE=-std=gnu99
 htmldir=man
-version=1.2.1
+version=1.0.14
 SED=sed
 
 ## Use these settings for a traditional /usr/local install
@@ -87,12 +87,12 @@
 	plugins.d/plymouth
 CPROGS=plugin-runner $(PLUGINS)
 PROGS=mandos mandos-keygen mandos-ctl mandos-monitor $(CPROGS)
-DOCS=mandos.8 mandos-keygen.8 mandos-monitor.8 mandos-ctl.8 \
-	mandos.conf.5 mandos-clients.conf.5 plugin-runner.8mandos \
+DOCS=mandos.8 plugin-runner.8mandos mandos-keygen.8 \
+	mandos-monitor.8 \
 	plugins.d/mandos-client.8mandos \
-	plugins.d/password-prompt.8mandos plugins.d/usplash.8mandos \
-	plugins.d/splashy.8mandos plugins.d/askpass-fifo.8mandos \
-	plugins.d/plymouth.8mandos
+	plugins.d/password-prompt.8mandos mandos.conf.5 \
+	plugins.d/usplash.8mandos plugins.d/splashy.8mandos \
+	plugins.d/askpass-fifo.8mandos mandos-clients.conf.5
 
 htmldocs=$(addsuffix .xhtml,$(DOCS))
 
@@ -140,13 +140,6 @@
 		 legalnotice.xml
 	$(DOCBOOKTOHTML)
 
-mandos-ctl.8: mandos-ctl.xml common.ent overview.xml \
-		legalnotice.xml
-	$(DOCBOOKTOMAN)
-mandos-ctl.8.xhtml: mandos-ctl.xml common.ent overview.xml \
-		 legalnotice.xml
-	$(DOCBOOKTOHTML)
-
 mandos.conf.5: mandos.conf.xml common.ent mandos-options.xml \
 		legalnotice.xml
 	$(DOCBOOKTOMAN)
@@ -300,10 +293,6 @@
 	fi
 	gzip --best --to-stdout mandos.8 \
 		> $(MANDIR)/man8/mandos.8.gz
-	gzip --best --to-stdout mandos-monitor.8 \
-		> $(MANDIR)/man8/mandos-monitor.8.gz
-	gzip --best --to-stdout mandos-ctl.8 \
-		> $(MANDIR)/man8/mandos-ctl.8.gz
 	gzip --best --to-stdout mandos.conf.5 \
 		> $(MANDIR)/man5/mandos.conf.5.gz
 	gzip --best --to-stdout mandos-clients.conf.5 \
@@ -350,18 +339,16 @@
 		> $(MANDIR)/man8/mandos-keygen.8.gz
 	gzip --best --to-stdout plugin-runner.8mandos \
 		> $(MANDIR)/man8/plugin-runner.8mandos.gz
+	gzip --best --to-stdout plugins.d/password-prompt.8mandos \
+		> $(MANDIR)/man8/password-prompt.8mandos.gz
 	gzip --best --to-stdout plugins.d/mandos-client.8mandos \
 		> $(MANDIR)/man8/mandos-client.8mandos.gz
-	gzip --best --to-stdout plugins.d/password-prompt.8mandos \
-		> $(MANDIR)/man8/password-prompt.8mandos.gz
 	gzip --best --to-stdout plugins.d/usplash.8mandos \
 		> $(MANDIR)/man8/usplash.8mandos.gz
 	gzip --best --to-stdout plugins.d/splashy.8mandos \
 		> $(MANDIR)/man8/splashy.8mandos.gz
 	gzip --best --to-stdout plugins.d/askpass-fifo.8mandos \
 		> $(MANDIR)/man8/askpass-fifo.8mandos.gz
-	gzip --best --to-stdout plugins.d/plymouth.8mandos \
-		> $(MANDIR)/man8/plymouth.8mandos.gz
 
 install-client: install-client-nokey
 # Post-installation stuff
@@ -376,8 +363,6 @@
 		$(PREFIX)/sbin/mandos-ctl \
 		$(PREFIX)/sbin/mandos-monitor \
 		$(MANDIR)/man8/mandos.8.gz \
-		$(MANDIR)/man8/mandos-monitor.8.gz \
-		$(MANDIR)/man8/mandos-ctl.8.gz \
 		$(MANDIR)/man5/mandos.conf.5.gz \
 		$(MANDIR)/man5/mandos-clients.conf.5.gz
 	update-rc.d -f mandos remove
@@ -399,14 +384,13 @@
 		$(INITRAMFSTOOLS)/hooks/mandos \
 		$(INITRAMFSTOOLS)/conf-hooks.d/mandos \
 		$(INITRAMFSTOOLS)/scripts/init-premount/mandos \
+		$(MANDIR)/man8/plugin-runner.8mandos.gz \
 		$(MANDIR)/man8/mandos-keygen.8.gz \
-		$(MANDIR)/man8/plugin-runner.8mandos.gz \
-		$(MANDIR)/man8/mandos-client.8mandos.gz
 		$(MANDIR)/man8/password-prompt.8mandos.gz \
 		$(MANDIR)/man8/usplash.8mandos.gz \
 		$(MANDIR)/man8/splashy.8mandos.gz \
 		$(MANDIR)/man8/askpass-fifo.8mandos.gz \
-		$(MANDIR)/man8/plymouth.8mandos.gz \
+		$(MANDIR)/man8/mandos-client.8mandos.gz
 	-rmdir $(PREFIX)/lib/mandos/plugins.d $(CONFDIR)/plugins.d \
 		 $(PREFIX)/lib/mandos $(CONFDIR) $(KEYDIR)
 	update-initramfs -k all -u

=== modified file 'NEWS'
--- NEWS	2010-10-02 17:23:41 +0000
+++ NEWS	2010-09-09 18:16:14 +0000
@@ -1,38 +1,6 @@
 This NEWS file records noteworthy changes, very tersely.
 See the manual for detailed information.
 
-Version 1.2.1 (2010-10-02)
-* Server:
-** mandos-monitor(8): Documentation bug fix: Key for removing client
-   is "R", not "r".
-
-Version 1.2 (2010-09-28)
-* Client:
-** New "plymouth" plugin to ask for a password using the Plymouth
-   graphical boot system.
-** The Mandos client now automatically chooses a network interface if
-   the DEVICE setting in /etc/initramfs-tools/initramfs.conf is set to
-   the empty string.  This is also the new default instead of "eth0".
-** The Mandos client --connect option now loops indefinitely until a
-   password is received from the specified server.
-** Bug fix: Quote directory correctly in mandos-keygen with --password
-** Bug fix: don't use "echo -e" in mandos-keygen; unsupported by dash.
-* Server:
-** Terminology change: clients are now "ENABLED" or "DISABLED", not
-   "valid" or "invalid".
-** New D-Bus API; see the file "DBUS-API".
-** New control utilities using the new D-Bus API:
-   + mandos-ctl		       A command-line based utility
-   + mandos-monitor	       A text-based GUI interface
-** New feature: manual interactive approval or denying of clients on a
-   case-by-case basis.
-** New --debuglevel option to control logging
-** Will not write PID file if --debug is passed
-** Bug fix: Avoid race conditions with short "interval" values or
-   fast checkers.
-** Bug fix: Don't try to bind to a network interface when none is
-   specified
-
 Version 1.0.14 (2009-10-25)
 Enable building without -pie and -fPIE if BROKEN_PIE is set.
 

=== modified file 'README'
--- README	2010-09-26 18:32:58 +0000
+++ README	2009-11-03 00:12:35 +0000
@@ -144,9 +144,7 @@
   plugins to run, all competing to be the first to find a password and
   provide it to the plugin runner.
   
-  Four additional plugins are provided:
-  * plymouth(8mandos)
-    This prompts for a password when using plymouth(8).
+  Three additional plugins are provided:
   * usplash(8mandos)
     This prompts for a password when using usplash(8).
   * splashy(8mandos)
@@ -162,8 +160,8 @@
 
 * Copyright
 
-    Copyright © 2008-2010 Teddy Hogeborn
-    Copyright © 2008-2010 Björn Påhlsson
+    Copyright © 2008,2009 Teddy Hogeborn
+    Copyright © 2008,2009 Björn Påhlsson
   
 ** License:
    

=== modified file 'TODO'
--- TODO	2010-09-26 18:32:58 +0000
+++ TODO	2010-09-15 17:17:46 +0000
@@ -2,6 +2,9 @@
 
 * Use _attribute_((nonnull)) wherever possible.
 
+* Release critical
+** plymouth.8mandos
+
 * mandos-client
 ** TODO [#B] use scandir(3) instead of readdir(3)
 ** TODO [#B] Prefix all debug output with "Mandos plugin " + program_invocation_short_name
@@ -81,8 +84,6 @@
 ** TODO make clients to a dict!
 ** TODO [#A] Limit approval_delay to max gnutls/tls timeout value
 ** TODO [#B] break the wait on approval_delay if connection dies
-** TODO Generate Client.runtime_expansions from client options + extra
-** TODO Allow %%(checker)s as a runtime expansion
 
 * mandos.xml
 ** Add mandos contact info in manual pages
@@ -103,7 +104,6 @@
 *** Properties popup
 ** Nicer crashes. Stack traces Messes up shell.
 *** Print a nice "We are sorry" message, save stack trace to log.
-** Show timeout countdown for approval
 
 * mandos-keygen
 ** TODO Loop until passwords match when run interactively

=== modified file 'common.ent'
--- common.ent	2010-10-02 17:23:41 +0000
+++ common.ent	2010-09-09 18:16:14 +0000
@@ -1,3 +1,3 @@
 <?xml version="1.0" encoding="UTF-8"?>
 <!-- Edited by Makefile -->
-<!ENTITY version "1.2.1">
+<!ENTITY version "1.0.14">

=== modified file 'debian/changelog'
--- debian/changelog	2010-10-02 17:53:34 +0000
+++ debian/changelog	2010-09-09 18:16:14 +0000
@@ -1,35 +1,3 @@
-mandos (1.2.1-2) unstable; urgency=low
-
-  * debian/source/format: New; contains "3.0 (quilt)".  Really.
-
- -- Björn Påhlsson <belorn@fukt.bsnet.se>  Sat, 02 Oct 2010 19:46:59 +0200
-
-mandos (1.2.1-1) unstable; urgency=low
-
-  * New upstream release.
-  * debian/source/format: New; contains "3.0 (quilt)".
-
- -- Björn Påhlsson <belorn@fukt.bsnet.se>  Sat, 02 Oct 2010 19:03:58 +0200
-
-mandos (1.2-1) unstable; urgency=low
-
-  * New upstream release.
-  * Makefile (LINK_FORTIFY_LD): Remove "-fPIE". (Closes: #557076)
-  * debian/control: Add gnupg dependency to "mandos-client" and removed it
-    from "mandos".  Added dependency on "python-urwid" "mandos" since the
-    new "mandos-monitor" utility needs it, and on "python (>=2.6) |
-    python-multiprocessing" since the Mandos server now uses it.
-  * debian/rules: Set BROKEN_PIE on mips and mipsel if a known buggy
-    version of binutils is used.
-  * debian/mandos.docs: Also install "/usr/share/doc/mandos/DBUS-API".
-  * debian/mandos.dirs: Added "etc/dbus-1/system.d".
-  * debian/mandos-client.README.Debian: Update info about DEVICE setting
-    of initramfs.conf.
-  * debian/mandos-client.README.Debian: Remove warning about --connect not
-    looping, since it now does.
-
- -- Teddy Hogeborn <teddy@fukt.bsnet.se>  Tue, 28 Sep 2010 20:46:11 +0200
-
 mandos (1.0.14-1) unstable; urgency=low (HIGH on mips and mipsel)
 
   * New upstream release.

=== modified file 'debian/control'
--- debian/control	2010-10-01 18:40:55 +0000
+++ debian/control	2010-09-09 22:26:35 +0000
@@ -7,7 +7,7 @@
 Build-Depends: debhelper (>= 7), docbook-xml, docbook-xsl,
 	libavahi-core-dev, libgpgme11-dev, libgnutls-dev, xsltproc,
 	pkg-config
-Standards-Version: 3.9.1
+Standards-Version: 3.8.3
 Vcs-Bzr: http://ftp.fukt.bsnet.se/pub/mandos/trunk
 Vcs-Browser: http://bzr.fukt.bsnet.se/loggerhead/mandos/trunk/files
 Homepage: http://www.fukt.bsnet.se/mandos
@@ -16,7 +16,7 @@
 Architecture: all
 Depends: ${misc:Depends}, python (>=2.5), python-gnutls, python-dbus,
 	python-avahi, python-gobject, avahi-daemon, adduser,
-	python-urwid, python (>=2.6) | python-multiprocessing
+	python-urwid
 Recommends: fping
 Description: a server giving encrypted passwords to Mandos clients
  This is the server part of the Mandos system, which allows

=== modified file 'debian/copyright'
--- debian/copyright	2010-09-26 18:32:58 +0000
+++ debian/copyright	2009-01-04 21:54:55 +0000
@@ -5,8 +5,8 @@
 Upstream-Source: <http://www.fukt.bsnet.se/mandos>
 
 Files: *
-Copyright: Copyright © 2008-2010 Teddy Hogeborn
-Copyright: Copyright © 2008-2010 Björn Påhlsson
+Copyright: Copyright © 2008,2009 Teddy Hogeborn
+Copyright: Copyright © 2008,2009 Björn Påhlsson
 License: GPL-3+
     This program is free software: you can redistribute it and/or
     modify it under the terms of the GNU General Public License as

=== modified file 'debian/mandos-client.README.Debian'
--- debian/mandos-client.README.Debian	2010-09-27 17:53:53 +0000
+++ debian/mandos-client.README.Debian	2009-09-08 06:28:20 +0000
@@ -1,11 +1,9 @@
 * Choose the Client Network Interface
   
-  Please make sure that the correct network interface is specified in
-  the DEVICE setting in the "/etc/initramfs-tools/initramfs.conf"
-  file.  If the setting is empty, the interface will be autodetected
-  at boot time, which may not be correct.  *If* the DEVICE setting is
-  changed, it will be necessary to update the initrd image by running
-  the command
+  You MUST make sure that the correct network interface is specified
+  in the DEVICE setting in the "/etc/initramfs-tools/initramfs.conf"
+  file.  *If* this is changed, it will be necessary to update the
+  initrd image by running the command
   
 	update-initramfs -k all -u
   
@@ -76,6 +74,9 @@
   instead of using ZeroConf.  The syntax for doing this is
   "mandos=connect:<IP_ADDRESS>:<PORT_NUMBER>".
   
+  Warning: this will cause the client to make exactly one attempt at
+  connecting, and then fail if it does not succeed.
+  
   For very advanced users, it it possible to specify simply
   "mandos=connect" on the kernel command line to make the system only
   set up the network (using the data in the "ip=" option) and not pass
@@ -83,4 +84,4 @@
   work, "--options-for=mandos-client:--connect=<ADDRESS>:<PORT>" needs
   to be manually added to the file "/etc/mandos/plugin-runner.conf".
 
- -- Teddy Hogeborn <teddy@fukt.bsnet.se>, Mon, 27 Sep 2010 19:53:21 +0200
+ -- Teddy Hogeborn <teddy@fukt.bsnet.se>, Tue,  8 Sep 2009 08:25:58 +0200

=== removed directory 'debian/source'
=== removed file 'debian/source/format'
--- debian/source/format	2010-10-02 17:41:05 +0000
+++ debian/source/format	1970-01-01 00:00:00 +0000
@@ -1,1 +0,0 @@
-3.0 (quilt)

=== modified file 'mandos'
--- mandos	2010-10-02 17:23:41 +0000
+++ mandos	2010-09-12 18:23:40 +0000
@@ -11,8 +11,8 @@
 # "AvahiService" class, and some lines in "main".
 # 
 # Everything else is
-# Copyright © 2008-2010 Teddy Hogeborn
-# Copyright © 2008-2010 Björn Påhlsson
+# Copyright © 2008,2009 Teddy Hogeborn
+# Copyright © 2008,2009 Björn Påhlsson
 # 
 # This program is free software: you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -81,7 +81,7 @@
         SO_BINDTODEVICE = None
 
 
-version = "1.2.1"
+version = "1.0.14"
 
 #logger = logging.getLogger(u'mandos')
 logger = logging.Logger(u'mandos')
@@ -240,43 +240,36 @@
     """A representation of a client host served by this server.
     
     Attributes:
-    _approved:   bool(); 'None' if not yet approved/disapproved
-    approval_delay: datetime.timedelta(); Time to wait for approval
-    approval_duration: datetime.timedelta(); Duration of one approval
+    name:       string; from the config file, used in log messages and
+                        D-Bus identifiers
+    fingerprint: string (40 or 32 hexadecimal digits); used to
+                 uniquely identify the client
+    secret:     bytestring; sent verbatim (over TLS) to client
+    host:       string; available for use by the checker command
+    created:    datetime.datetime(); (UTC) object creation
+    last_enabled: datetime.datetime(); (UTC)
+    enabled:    bool()
+    last_checked_ok: datetime.datetime(); (UTC) or None
+    timeout:    datetime.timedelta(); How long from last_checked_ok
+                                      until this client is disabled
+    interval:   datetime.timedelta(); How often to start a new checker
+    disable_hook:  If set, called by disable() as disable_hook(self)
     checker:    subprocess.Popen(); a running checker process used
                                     to see if the client lives.
                                     'None' if no process is running.
-    checker_callback_tag: a gobject event source tag, or None
-    checker_command: string; External command which is run to check
-                     if client lives.  %() expansions are done at
+    checker_initiator_tag: a gobject event source tag, or None
+    disable_initiator_tag: - '' -
+    checker_callback_tag:  - '' -
+    checker_command: string; External command which is run to check if
+                     client lives.  %() expansions are done at
                      runtime with vars(self) as dict, so that for
                      instance %(name)s can be used in the command.
-    checker_initiator_tag: a gobject event source tag, or None
-    created:    datetime.datetime(); (UTC) object creation
     current_checker_command: string; current running checker_command
-    disable_hook:  If set, called by disable() as disable_hook(self)
-    disable_initiator_tag: a gobject event source tag, or None
-    enabled:    bool()
-    fingerprint: string (40 or 32 hexadecimal digits); used to
-                 uniquely identify the client
-    host:       string; available for use by the checker command
-    interval:   datetime.timedelta(); How often to start a new checker
-    last_approval_request: datetime.datetime(); (UTC) or None
-    last_checked_ok: datetime.datetime(); (UTC) or None
-    last_enabled: datetime.datetime(); (UTC)
-    name:       string; from the config file, used in log messages and
-                        D-Bus identifiers
-    secret:     bytestring; sent verbatim (over TLS) to client
-    timeout:    datetime.timedelta(); How long from last_checked_ok
-                                      until this client is disabled
-    runtime_expansions: Allowed attributes for runtime expansion.
+    approval_delay: datetime.timedelta(); Time to wait for approval
+    _approved:   bool(); 'None' if not yet approved/disapproved
+    approval_duration: datetime.timedelta(); Duration of one approval
     """
     
-    runtime_expansions = (u"approval_delay", u"approval_duration",
-                          u"created", u"enabled", u"fingerprint",
-                          u"host", u"interval", u"last_checked_ok",
-                          u"last_enabled", u"name", u"timeout")
-    
     @staticmethod
     def _timedelta_to_milliseconds(td):
         "Convert a datetime.timedelta() to milliseconds"
@@ -322,7 +315,6 @@
         self.host = config.get(u"host", u"")
         self.created = datetime.datetime.utcnow()
         self.enabled = False
-        self.last_approval_request = None
         self.last_enabled = None
         self.last_checked_ok = None
         self.timeout = string_to_delta(config[u"timeout"])
@@ -424,9 +416,6 @@
                                       (self.timeout_milliseconds(),
                                        self.disable))
     
-    def need_approval(self):
-        self.last_approval_request = datetime.datetime.utcnow()
-    
     def start_checker(self):
         """Start a new checker subprocess if one is not running.
         
@@ -461,14 +450,12 @@
                 command = self.checker_command % self.host
             except TypeError:
                 # Escape attributes for the shell
-                escaped_attrs = dict(
-                    (attr,
-                     re.escape(unicode(str(getattr(self, attr, u"")),
-                                       errors=
-                                       u'replace')))
-                    for attr in
-                    self.runtime_expansions)
-
+                escaped_attrs = dict((key,
+                                      re.escape(unicode(str(val),
+                                                        errors=
+                                                        u'replace')))
+                                     for key, val in
+                                     vars(self).iteritems())
                 try:
                     command = self.checker_command % escaped_attrs
                 except TypeError, error:
@@ -716,10 +703,6 @@
     dbus_object_path: dbus.ObjectPath
     bus: dbus.SystemBus()
     """
-    
-    runtime_expansions = (Client.runtime_expansions
-                          + (u"dbus_object_path",))
-    
     # dbus.service.Object doesn't use super(), so we can't either.
     
     def __init__(self, bus = None, *args, **kwargs):
@@ -728,11 +711,9 @@
         Client.__init__(self, *args, **kwargs)
         # Only now, when this client is initialized, can it show up on
         # the D-Bus
-        client_object_name = unicode(self.name).translate(
-            {ord(u"."): ord(u"_"),
-             ord(u"-"): ord(u"_")})
         self.dbus_object_path = (dbus.ObjectPath
-                                 (u"/clients/" + client_object_name))
+                                 (u"/clients/"
+                                  + self.name.replace(u".", u"_")))
         DBusObjectWithProperties.__init__(self, self.bus,
                                           self.dbus_object_path)
         
@@ -820,15 +801,6 @@
                                     variant_level=1)))
         return r
     
-    def need_approval(self, *args, **kwargs):
-        r = Client.need_approval(self, *args, **kwargs)
-        # Emit D-Bus signal
-        self.PropertyChanged(
-            dbus.String(u"LastApprovalRequest"),
-            (self._datetime_to_dbus(self.last_approval_request,
-                                    variant_level=1)))
-        return r
-    
     def start_checker(self, *args, **kwargs):
         old_checker = self.checker
         if self.checker is not None:
@@ -909,15 +881,15 @@
     @dbus.service.signal(_interface, signature=u"tb")
     def NeedApproval(self, timeout, default):
         "D-Bus signal"
-        return self.need_approval()
+        pass
     
     ## Methods
-    
+
     # Approve - method
     @dbus.service.method(_interface, in_signature=u"b")
     def Approve(self, value):
         self.approve(value)
-    
+
     # CheckedOK - method
     @dbus.service.method(_interface)
     def CheckedOK(self):
@@ -1043,15 +1015,6 @@
         return dbus.String(self._datetime_to_dbus(self
                                                   .last_checked_ok))
     
-    # LastApprovalRequest - property
-    @dbus_service_property(_interface, signature=u"s", access=u"read")
-    def LastApprovalRequest_dbus_property(self):
-        if self.last_approval_request is None:
-            return dbus.String(u"")
-        return dbus.String(self.
-                           _datetime_to_dbus(self
-                                             .last_approval_request))
-    
     # Timeout - property
     @dbus_service_property(_interface, signature=u"t",
                            access=u"readwrite")
@@ -1545,7 +1508,7 @@
                                u"dress: %s", fpr, address)
                 if self.use_dbus:
                     # Emit D-Bus signal
-                    mandos_dbus_service.ClientNotFound(fpr, address[0])
+                    mandos_dbus_service.ClientNotFound(fpr, address)
                 parent_pipe.send(False)
                 return False
             
@@ -1684,7 +1647,7 @@
     parser.add_option("--debug", action=u"store_true",
                       help=u"Debug mode; run in foreground and log to"
                       u" terminal")
-    parser.add_option("--debuglevel", type=u"string", metavar="LEVEL",
+    parser.add_option("--debuglevel", type=u"string", metavar="Level",
                       help=u"Debug level for stdout output")
     parser.add_option("--priority", type=u"string", help=u"GnuTLS"
                       u" priority string (see GnuTLS documentation)")
@@ -1788,12 +1751,11 @@
                               gnutls_priority=
                               server_settings[u"priority"],
                               use_dbus=use_dbus)
-    if not debug:
-        pidfilename = u"/var/run/mandos.pid"
-        try:
-            pidfile = open(pidfilename, u"w")
-        except IOError:
-            logger.error(u"Could not open file %r", pidfilename)
+    pidfilename = u"/var/run/mandos.pid"
+    try:
+        pidfile = open(pidfilename, u"w")
+    except IOError:
+        logger.error(u"Could not open file %r", pidfilename)
     
     try:
         uid = pwd.getpwnam(u"_mandos").pw_uid
@@ -1901,22 +1863,21 @@
     if not tcp_server.clients:
         logger.warning(u"No clients defined")
         
+    try:
+        with pidfile:
+            pid = os.getpid()
+            pidfile.write(str(pid) + "\n")
+        del pidfile
+    except IOError:
+        logger.error(u"Could not write to file %r with PID %d",
+                     pidfilename, pid)
+    except NameError:
+        # "pidfile" was never created
+        pass
+    del pidfilename
+    
     if not debug:
-        try:
-            with pidfile:
-                pid = os.getpid()
-                pidfile.write(str(pid) + "\n")
-            del pidfile
-        except IOError:
-            logger.error(u"Could not write to file %r with PID %d",
-                         pidfilename, pid)
-        except NameError:
-            # "pidfile" was never created
-            pass
-        del pidfilename
-        
         signal.signal(signal.SIGINT, signal.SIG_IGN)
-
     signal.signal(signal.SIGHUP, lambda signum, frame: sys.exit())
     signal.signal(signal.SIGTERM, lambda signum, frame: sys.exit())
     

=== modified file 'mandos-clients.conf.xml'
--- mandos-clients.conf.xml	2010-09-27 18:57:12 +0000
+++ mandos-clients.conf.xml	2010-09-12 03:00:40 +0000
@@ -3,7 +3,7 @@
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY CONFNAME "mandos-clients.conf">
 <!ENTITY CONFPATH "<filename>/etc/mandos/clients.conf</filename>">
-<!ENTITY TIMESTAMP "2010-09-26">
+<!ENTITY TIMESTAMP "2010-09-12">
 <!ENTITY % common SYSTEM "common.ent">
 %common;
 ]>
@@ -34,7 +34,6 @@
     <copyright>
       <year>2008</year>
       <year>2009</year>
-      <year>2010</year>
       <holder>Teddy Hogeborn</holder>
       <holder>Björn Påhlsson</holder>
     </copyright>
@@ -101,53 +100,53 @@
     <variablelist>
       
       <varlistentry>
-	<term><option>approval_delay<literal> = </literal><replaceable
-	>TIME</replaceable></option></term>
-	<listitem>
-	  <para>
-	    This option is <emphasis>optional</emphasis>.
-	  </para>
-	  <para>
-	    How long to wait for external approval before resorting to
-	    use the <option>approved_by_default</option> value.  The
-	    default is <quote>0s</quote>, i.e. not to wait.
-	  </para>
-	  <para>
-	    The format of <replaceable>TIME</replaceable> is the same
-	    as for <varname>timeout</varname> below.
-	  </para>
-	</listitem>
-      </varlistentry>
-      
-      <varlistentry>
-	<term><option>approval_duration<literal> = </literal
-        ><replaceable>TIME</replaceable></option></term>
-	<listitem>
-	  <para>
-	    This option is <emphasis>optional</emphasis>.
-	  </para>
-	  <para>
-	    How long an external approval lasts.  The default is 1
-	    second.
-	  </para>
-	  <para>
-	    The format of <replaceable>TIME</replaceable> is the same
-	    as for <varname>timeout</varname> below.
-	  </para>
-	</listitem>
-      </varlistentry>
-      
-      <varlistentry>
-	<term><option>approved_by_default<literal> = </literal
-          >{ <literal >1</literal> | <literal>yes</literal> | <literal
-	  >true</literal> | <literal>on</literal> | <literal
-	  >0</literal> | <literal>no</literal> | <literal
-	  >false</literal> | <literal>off</literal> }</option></term>
-	<listitem>
-	  <para>
-	    Whether to approve a client by default after
-	    the <option>approval_delay</option>.  The default
-	    is <quote>True</quote>.
+	<term><option>timeout<literal> = </literal><replaceable
+	>TIME</replaceable></option></term>
+	<listitem>
+	  <para>
+	    This option is <emphasis>optional</emphasis>.
+	  </para>
+	  <para>
+	    The timeout is how long the server will wait (for either a
+	    successful checker run or a client receiving its secret)
+	    until a client is disabled and not allowed to get the data
+	    this server holds.  By default Mandos will use 1 hour.
+	  </para>
+	  <para>
+	    The <replaceable>TIME</replaceable> is specified as a
+	    space-separated number of values, each of which is a
+	    number and a one-character suffix.  The suffix must be one
+	    of <quote>d</quote>, <quote>s</quote>, <quote>m</quote>,
+	    <quote>h</quote>, and <quote>w</quote> for days, seconds,
+	    minutes, hours, and weeks, respectively.  The values are
+	    added together to give the total time value, so all of
+	    <quote><literal>330s</literal></quote>,
+	    <quote><literal>110s 110s 110s</literal></quote>, and
+	    <quote><literal>5m 30s</literal></quote> will give a value
+	    of five minutes and thirty seconds.
+	  </para>
+	</listitem>
+      </varlistentry>
+      
+      <varlistentry>
+	<term><option>interval<literal> = </literal><replaceable
+	>TIME</replaceable></option></term>
+	<listitem>
+	  <para>
+	    This option is <emphasis>optional</emphasis>.
+	  </para>
+	  <para>
+	    How often to run the checker to confirm that a client is
+	    still up.  <emphasis>Note:</emphasis> a new checker will
+	    not be started if an old one is still running.  The server
+	    will wait for a checker to complete until the above
+	    <quote><varname>timeout</varname></quote> occurs, at which
+	    time the client will be disabled, and any running checker
+	    killed.  The default interval is 5 minutes.
+	  </para>
+	  <para>
+	    The format of <replaceable>TIME</replaceable> is the same
+	    as for <varname>timeout</varname> above.
 	  </para>
 	</listitem>
       </varlistentry>
@@ -197,70 +196,6 @@
       </varlistentry>
       
       <varlistentry>
-	<term><option><literal>host = </literal><replaceable
-	>STRING</replaceable></option></term>
-	<listitem>
-	  <para>
-	    This option is <emphasis>optional</emphasis>, but highly
-	    <emphasis>recommended</emphasis> unless the
-	    <option>checker</option> option is modified to a
-	    non-standard value without <quote>%%(host)s</quote> in it.
-	  </para>
-	  <para>
-	    Host name for this client.  This is not used by the server
-	    directly, but can be, and is by default, used by the
-	    checker.  See the <option>checker</option> option.
-	  </para>
-	</listitem>
-      </varlistentry>
-      
-      <varlistentry>
-	<term><option>interval<literal> = </literal><replaceable
-	>TIME</replaceable></option></term>
-	<listitem>
-	  <para>
-	    This option is <emphasis>optional</emphasis>.
-	  </para>
-	  <para>
-	    How often to run the checker to confirm that a client is
-	    still up.  <emphasis>Note:</emphasis> a new checker will
-	    not be started if an old one is still running.  The server
-	    will wait for a checker to complete until the below
-	    <quote><varname>timeout</varname></quote> occurs, at which
-	    time the client will be disabled, and any running checker
-	    killed.  The default interval is 5 minutes.
-	  </para>
-	  <para>
-	    The format of <replaceable>TIME</replaceable> is the same
-	    as for <varname>timeout</varname> below.
-	  </para>
-	</listitem>
-      </varlistentry>
-      
-      <varlistentry>
-	<term><option>secfile<literal> = </literal><replaceable
-	>FILENAME</replaceable></option></term>
-	<listitem>
-	  <para>
-	    This option is only used if <option>secret</option> is not
-	    specified, in which case this option is
-	    <emphasis>required</emphasis>.
-	  </para>
-	  <para>
-	    Similar to the <option>secret</option>, except the secret
-	    data is in an external file.  The contents of the file
-	    should <emphasis>not</emphasis> be base64-encoded, but
-	    will be sent to clients verbatim.
-	  </para>
-	  <para>
-	    File names of the form <filename>~user/foo/bar</filename>
-	    and <filename>$<envar>ENVVAR</envar>/foo/bar</filename>
-	    are supported.
-	  </para>
-	</listitem>
-      </varlistentry>
-      
-      <varlistentry>
 	<term><option>secret<literal> = </literal><replaceable
 	>BASE64_ENCODED_DATA</replaceable></option></term>
 	<listitem>
@@ -291,30 +226,94 @@
       </varlistentry>
       
       <varlistentry>
-	<term><option>timeout<literal> = </literal><replaceable
+	<term><option>secfile<literal> = </literal><replaceable
+	>FILENAME</replaceable></option></term>
+	<listitem>
+	  <para>
+	    This option is only used if <option>secret</option> is not
+	    specified, in which case this option is
+	    <emphasis>required</emphasis>.
+	  </para>
+	  <para>
+	    Similar to the <option>secret</option>, except the secret
+	    data is in an external file.  The contents of the file
+	    should <emphasis>not</emphasis> be base64-encoded, but
+	    will be sent to clients verbatim.
+	  </para>
+	  <para>
+	    File names of the form <filename>~user/foo/bar</filename>
+	    and <filename>$<envar>ENVVAR</envar>/foo/bar</filename>
+	    are supported.
+	  </para>
+	</listitem>
+      </varlistentry>
+      
+      <varlistentry>
+	<term><option><literal>host = </literal><replaceable
+	>STRING</replaceable></option></term>
+	<listitem>
+	  <para>
+	    This option is <emphasis>optional</emphasis>, but highly
+	    <emphasis>recommended</emphasis> unless the
+	    <option>checker</option> option is modified to a
+	    non-standard value without <quote>%%(host)s</quote> in it.
+	  </para>
+	  <para>
+	    Host name for this client.  This is not used by the server
+	    directly, but can be, and is by default, used by the
+	    checker.  See the <option>checker</option> option.
+	  </para>
+	</listitem>
+      </varlistentry>
+      
+      <varlistentry>
+	<term><option>approved_by_default<literal> = </literal
+          >{ <literal >1</literal> | <literal>yes</literal> | <literal
+	  >true</literal> | <literal>on</literal> | <literal
+	  >0</literal> | <literal>no</literal> | <literal
+	  >false</literal> | <literal>off</literal> }</option></term>
+	<listitem>
+	  <para>
+	    Whether to approve a client by default after
+	    the <option>approval_delay</option>.  The default
+	    is <quote>True</quote>.
+	  </para>
+	</listitem>
+      </varlistentry>
+      
+      <varlistentry>
+	<term><option>approval_delay<literal> = </literal><replaceable
 	>TIME</replaceable></option></term>
 	<listitem>
 	  <para>
 	    This option is <emphasis>optional</emphasis>.
 	  </para>
 	  <para>
-	    The timeout is how long the server will wait (for either a
-	    successful checker run or a client receiving its secret)
-	    until a client is disabled and not allowed to get the data
-	    this server holds.  By default Mandos will use 1 hour.
-	  </para>
-	  <para>
-	    The <replaceable>TIME</replaceable> is specified as a
-	    space-separated number of values, each of which is a
-	    number and a one-character suffix.  The suffix must be one
-	    of <quote>d</quote>, <quote>s</quote>, <quote>m</quote>,
-	    <quote>h</quote>, and <quote>w</quote> for days, seconds,
-	    minutes, hours, and weeks, respectively.  The values are
-	    added together to give the total time value, so all of
-	    <quote><literal>330s</literal></quote>,
-	    <quote><literal>110s 110s 110s</literal></quote>, and
-	    <quote><literal>5m 30s</literal></quote> will give a value
-	    of five minutes and thirty seconds.
+	    How long to wait for external approval before resorting to
+	    use the <option>approved_by_default</option> value.  The
+	    default is <quote>0s</quote>, i.e. not to wait.
+	  </para>
+	  <para>
+	    The format of <replaceable>TIME</replaceable> is the same
+	    as for <varname>timeout</varname> above.
+	  </para>
+	</listitem>
+      </varlistentry>
+      
+      <varlistentry>
+	<term><option>approval_duration<literal> = </literal
+        ><replaceable>TIME</replaceable></option></term>
+	<listitem>
+	  <para>
+	    This option is <emphasis>optional</emphasis>.
+	  </para>
+	  <para>
+	    How long an external approval lasts.  The default is 1
+	    second.
+	  </para>
+	  <para>
+	    The format of <replaceable>TIME</replaceable> is the same
+	    as for <varname>timeout</varname> above.
 	  </para>
 	</listitem>
       </varlistentry>
@@ -357,28 +356,10 @@
 	<quote><literal>%%(<replaceable>foo</replaceable>)s</literal
 	></quote> will be replaced by the value of the attribute
 	<varname>foo</varname> of the internal
-	<quote><classname>Client</classname></quote> object in the
-	Mandos server.  The currently allowed values for
-	<replaceable>foo</replaceable> are:
-	<quote><literal>approval_delay</literal></quote>,
-	<quote><literal>approval_duration</literal></quote>,
-	<quote><literal>created</literal></quote>,
-	<quote><literal>enabled</literal></quote>,
-	<quote><literal>fingerprint</literal></quote>,
-	<quote><literal>host</literal></quote>,
-	<quote><literal>interval</literal></quote>,
-	<quote><literal>last_approval_request</literal></quote>,
-	<quote><literal>last_checked_ok</literal></quote>,
-	<quote><literal>last_enabled</literal></quote>,
-	<quote><literal>name</literal></quote>,
-	<quote><literal>timeout</literal></quote>, and, if using
-	D-Bus, <quote><literal>dbus_object_path</literal></quote>.
-	See the source code for details.  <emphasis role="strong"
-	>Currently, <emphasis>none</emphasis> of these attributes
-	except <quote><literal>host</literal></quote> are guaranteed
-	to be valid in future versions.</emphasis> Therefore, please
-	let the authors know of any attributes that are useful so they
-	may be preserved to any new versions of this software.
+	<quote><classname>Client</classname></quote> object.  See the
+	source code for details, and let the authors know of any
+	attributes that are useful so they may be preserved to any new
+	versions of this software.
       </para>
       <para>
 	Note that this means that, in order to include an actual

=== modified file 'mandos-ctl'
--- mandos-ctl	2010-10-02 17:23:41 +0000
+++ mandos-ctl	2010-09-12 18:23:40 +0000
@@ -1,26 +1,5 @@
 #!/usr/bin/python
 # -*- mode: python; coding: utf-8 -*-
-# 
-# Mandos Monitor - Control and monitor the Mandos server
-# 
-# Copyright © 2008-2010 Teddy Hogeborn
-# Copyright © 2008-2010 Björn Påhlsson
-# 
-# This program is free software: you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation, either version 3 of the License, or
-# (at your option) any later version.
-#
-#     This program is distributed in the hope that it will be useful,
-#     but WITHOUT ANY WARRANTY; without even the implied warranty of
-#     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-#     GNU General Public License for more details.
-# 
-# You should have received a copy of the GNU General Public License
-# along with this program.  If not, see <http://www.gnu.org/licenses/>.
-# 
-# Contact the authors at <mandos@fukt.bsnet.se>.
-# 
 
 from __future__ import division
 import sys
@@ -38,17 +17,12 @@
     'Enabled': u'Enabled',
     'Timeout': u'Timeout',
     'LastCheckedOK': u'Last Successful Check',
-    'LastApprovalRequest': u'Last Approval Request',
     'Created': u'Created',
     'Interval': u'Interval',
     'Host': u'Host',
     'Fingerprint': u'Fingerprint',
     'CheckerRunning': u'Check Is Running',
     'LastEnabled': u'Last Enabled',
-    'ApprovalPending': u'Approval Is Pending',
-    'ApprovedByDefault': u'Approved By Default',
-    'ApprovalDelay': u"Approval Delay",
-    'ApprovalDuration': u"Approval Duration",
     'Checker': u'Checker',
     }
 defaultkeywords = ('Name', 'Enabled', 'Timeout', 'LastCheckedOK')
@@ -57,7 +31,7 @@
 server_path = '/'
 server_interface = domain + '.Mandos'
 client_interface = domain + '.Mandos.Client'
-version = "1.2.1"
+version = "1.0.14"
 
 def timedelta_to_milliseconds(td):
     "Convert a datetime.timedelta object to milliseconds"
@@ -119,8 +93,7 @@
     def valuetostring(value, keyword):
         if type(value) is dbus.Boolean:
             return u"Yes" if value else u"No"
-        if keyword in (u"Timeout", u"Interval", u"ApprovalDelay",
-                       u"ApprovalDuration"):
+        if keyword in (u"timeout", u"interval"):
             return milliseconds_to_string(value)
         return unicode(value)
     
@@ -137,7 +110,6 @@
     for client in clients:
         print format_string % tuple(valuetostring(client[key], key)
                                     for key in keywords)
-
 def has_actions(options):
     return any((options.enable,
                 options.disable,
@@ -149,9 +121,6 @@
                 options.checker is not None,
                 options.timeout is not None,
                 options.interval is not None,
-                options.approved_by_default is not None,
-                options.approval_delay is not None,
-                options.approval_duration is not None,
                 options.host is not None,
                 options.secret is not None,
                 options.approve,
@@ -183,16 +152,6 @@
 	                  help="Set timeout for client")
 	parser.add_option("-i", "--interval", type="string",
 	                  help="Set checker interval for client")
-        parser.add_option("--approve-by-default", action="store_true",
-                          dest=u"approved_by_default",
-                          help="Set client to be approved by default")
-        parser.add_option("--deny-by-default", action="store_false",
-                          dest=u"approved_by_default",
-                          help="Set client to be denied by default")
-        parser.add_option("--approval-delay", type="string",
-                          help="Set delay before client approve/deny")
-        parser.add_option("--approval-duration", type="string",
-                          help="Set duration of one client approval")
 	parser.add_option("-H", "--host", type="string",
 	                  help="Set host for client")
 	parser.add_option("-s", "--secret", type="string",
@@ -202,15 +161,14 @@
 	parser.add_option("-D", "--deny", action="store_true",
 	                  help="Deny any current client request")
 	options, client_names = parser.parse_args()
-        
+
         if has_actions(options) and not client_names and not options.all:
-            parser.error('Options require clients names or --all.')
+            parser.error('Options requires clients names or --all.')
         if options.verbose and has_actions(options):
-            parser.error('--verbose can only be used alone or with'
-                         ' --all.')
+            parser.error('Verbose option can only be used alone or with --all.')
         if options.all and not has_actions(options):
-            parser.error('--all requires an action.')
-        
+            parser.error('--all requires an action')
+            
         try:
             bus = dbus.SystemBus()
             mandos_dbus_objc = bus.get_object(busname, server_path)
@@ -237,19 +195,17 @@
             print >> sys.stderr, "Access denied: Accessing mandos server through dbus."
             sys.exit(1)
             
-	# Compile dict of (clients: properties) to process
-	clients={}
-        
+	# Compile list of clients to process
+	clients=[]
+
         if options.all or not client_names:
-            clients = dict((bus.get_object(busname, path), properties)
-                           for path, properties in
-                           mandos_clients.iteritems())
+            clients = (bus.get_object(busname, path) for path in mandos_clients.iterkeys())
         else:
             for name in client_names:
                 for path, client in mandos_clients.iteritems():
                     if client['Name'] == name:
                         client_objc = bus.get_object(busname, path)
-                        clients[client_objc] = client
+                        clients.append(client_objc)
                         break
                 else:
                     print >> sys.stderr, "Client not found on server: %r" % name
@@ -257,17 +213,13 @@
             
 	if not has_actions(options) and clients:
 	    if options.verbose:
-	        keywords = ('Name', 'Enabled', 'Timeout',
-                            'LastCheckedOK', 'Created', 'Interval',
-                            'Host', 'Fingerprint', 'CheckerRunning',
-                            'LastEnabled', 'ApprovalPending',
-                            'ApprovedByDefault',
-                            'LastApprovalRequest', 'ApprovalDelay',
-                            'ApprovalDuration', 'Checker')
+	        keywords = ('Name', 'Enabled', 'Timeout', 'LastCheckedOK',
+	                    'Created', 'Interval', 'Host', 'Fingerprint',
+	                    'CheckerRunning', 'LastEnabled', 'Checker')
             else:
                 keywords = defaultkeywords
-            
-	    print_clients(clients.values(), keywords)
+                
+	    print_clients(mandos_clients.values(), keywords)
         else:
             # Process each client in the list by all selected options
             for client in clients:
@@ -299,39 +251,19 @@
                                timedelta_to_milliseconds
                                (string_to_delta(options.interval)),
                                dbus_interface=dbus.PROPERTIES_IFACE)
-                if options.approval_delay:
-                    client.Set(client_interface, u"ApprovalDelay",
-                               timedelta_to_milliseconds
-                               (string_to_delta(options.
-                                                approval_delay)),
-                               dbus_interface=dbus.PROPERTIES_IFACE)
-                if options.approval_duration:
-                    client.Set(client_interface, u"ApprovalDuration",
-                               timedelta_to_milliseconds
-                               (string_to_delta(options.
-                                                approval_duration)),
-                               dbus_interface=dbus.PROPERTIES_IFACE)
                 if options.timeout:
                     client.Set(client_interface, u"Timeout",
-                               timedelta_to_milliseconds
-                               (string_to_delta(options.timeout)),
+                               timedelta_to_milliseconds(string_to_delta
+                                                         (options.timeout)),
                                dbus_interface=dbus.PROPERTIES_IFACE)
                 if options.secret:
                     client.Set(client_interface, u"Secret",
-                               dbus.ByteArray(open(options.secret,
-                                                   u'rb').read()),
-                               dbus_interface=dbus.PROPERTIES_IFACE)
-                if options.approved_by_default is not None:
-                    client.Set(client_interface, u"ApprovedByDefault",
-                               dbus.Boolean(options
-                                            .approved_by_default),
+                               dbus.ByteArray(open(options.secret, u'rb').read()),
                                dbus_interface=dbus.PROPERTIES_IFACE)
                 if options.approve:
-                    client.Approve(dbus.Boolean(True),
-                                   dbus_interface=client_interface)
-                elif options.deny:
-                    client.Approve(dbus.Boolean(False),
-                                   dbus_interface=client_interface)
+                    client.Approve(dbus.Boolean(True), dbus_interface=client_interface)
+                if options.deny:
+                    client.Approve(dbus.Boolean(False), dbus_interface=client_interface)
 
 if __name__ == '__main__':
     main()

=== removed file 'mandos-ctl.xml'
--- mandos-ctl.xml	2010-09-25 23:52:17 +0000
+++ mandos-ctl.xml	1970-01-01 00:00:00 +0000
@@ -1,570 +0,0 @@
-<?xml version="1.0" encoding="UTF-8"?>
-<!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
-	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
-<!ENTITY COMMANDNAME "mandos-ctl">
-<!ENTITY TIMESTAMP "2010-09-26">
-<!ENTITY % common SYSTEM "common.ent">
-%common;
-]>
-
-<refentry xmlns:xi="http://www.w3.org/2001/XInclude">
-  <refentryinfo>
-    <title>Mandos Manual</title>
-    <!-- NWalsh’s docbook scripts use this to generate the footer: -->
-    <productname>Mandos</productname>
-    <productnumber>&version;</productnumber>
-    <date>&TIMESTAMP;</date>
-    <authorgroup>
-      <author>
-	<firstname>Björn</firstname>
-	<surname>Påhlsson</surname>
-	<address>
-	  <email>belorn@fukt.bsnet.se</email>
-	</address>
-      </author>
-      <author>
-	<firstname>Teddy</firstname>
-	<surname>Hogeborn</surname>
-	<address>
-	  <email>teddy@fukt.bsnet.se</email>
-	</address>
-      </author>
-    </authorgroup>
-    <copyright>
-      <year>2010</year>
-      <holder>Teddy Hogeborn</holder>
-      <holder>Björn Påhlsson</holder>
-    </copyright>
-    <xi:include href="legalnotice.xml"/>
-  </refentryinfo>
-  
-  <refmeta>
-    <refentrytitle>&COMMANDNAME;</refentrytitle>
-    <manvolnum>8</manvolnum>
-  </refmeta>
-  
-  <refnamediv>
-    <refname><command>&COMMANDNAME;</command></refname>
-    <refpurpose>
-      Control the operation of the Mandos server
-    </refpurpose>
-  </refnamediv>
-  
-  <refsynopsisdiv>
-    <cmdsynopsis>
-      <command>&COMMANDNAME;</command>
-      <group>
-	<arg choice="plain"><option>--enable</option></arg>
-	<arg choice="plain"><option>-e</option></arg>
-	<sbr/>
-	<arg choice="plain"><option>--disable</option></arg>
-	<arg choice="plain"><option>-d</option></arg>
-      </group>
-      <sbr/>
-      <group>
-	<arg choice="plain"><option>--bump-timeout</option></arg>
-	<arg choice="plain"><option>-b</option></arg>
-      </group>
-      <sbr/>
-      <group>
-	<arg choice="plain"><option>--start-checker</option></arg>
-      </group>
-      <sbr/>
-      <group>
-	<arg choice="plain"><option>--stop-checker</option></arg>
-      </group>
-      <sbr/>
-      <group>
-	<arg choice="plain"><option>--remove</option></arg>
-	<arg choice="plain"><option>-r</option></arg>
-      </group>
-      <sbr/>
-      <group>
-	<arg choice="plain"><option>--checker
-	<replaceable>COMMAND</replaceable></option></arg>
-	<arg choice="plain"><option>-c
-	<replaceable>COMMAND</replaceable></option></arg>
-      </group>
-      <sbr/>
-      <group>
-	<arg choice="plain"><option>--timeout
-	<replaceable>TIME</replaceable></option></arg>
-	<arg choice="plain"><option>-t
-	<replaceable>TIME</replaceable></option></arg>
-      </group>
-      <sbr/>
-      <group>
-	<arg choice="plain"><option>--interval
-	<replaceable>TIME</replaceable></option></arg>
-	<arg choice="plain"><option>-i
-	<replaceable>TIME</replaceable></option></arg>
-      </group>
-      <sbr/>
-      <group>
-	<arg choice="plain"><option>--approve-by-default</option
-        ></arg>
-	<sbr/>
-	<arg choice="plain"><option>--deny-by-default</option></arg>
-      </group>
-      <sbr/>
-      <group>
-	<arg choice="plain"><option>--approval-delay
-	<replaceable>TIME</replaceable></option></arg>
-      </group>
-      <sbr/>
-      <group>
-	<arg choice="plain"><option>--approval-duration
-	<replaceable>TIME</replaceable></option></arg>
-      </group>
-      <sbr/>
-      <group>
-	<arg choice="plain"><option>--interval
-	<replaceable>TIME</replaceable></option></arg>
-	<arg choice="plain"><option>-i
-	<replaceable>TIME</replaceable></option></arg>
-      </group>
-      <sbr/>
-      <group>
-	<arg choice="plain"><option>--host
-	<replaceable>STRING</replaceable></option></arg>
-	<arg choice="plain"><option>-H
-	<replaceable>STRING</replaceable></option></arg>
-      </group>
-      <sbr/>
-      <group>
-	<arg choice="plain"><option>--secret
-	<replaceable>FILENAME</replaceable></option></arg>
-	<arg choice="plain"><option>-s
-	<replaceable>FILENAME</replaceable></option></arg>
-      </group>
-      <sbr/>
-      <group>
-	<arg choice="plain"><option>--approve</option></arg>
-	<arg choice="plain"><option>-A</option></arg>
-	<sbr/>
-	<arg choice="plain"><option>--deny</option></arg>
-	<arg choice="plain"><option>-D</option></arg>
-      </group>
-      <sbr/>
-      <group choice="req">
-	<arg choice="plain"><option>--all</option></arg>
-	<arg choice="plain"><option>-a</option></arg>
-	<arg rep='repeat' choice='plain'>
-	  <replaceable>CLIENT</replaceable>
-	</arg>
-      </group>
-    </cmdsynopsis>
-    <cmdsynopsis>
-      <command>&COMMANDNAME;</command>
-      <group>
-	<arg choice="plain"><option>--verbose</option></arg>
-	<arg choice="plain"><option>-v</option></arg>
-      </group>
-      <group>
-	<arg rep='repeat' choice='plain'>
-	  <replaceable>CLIENT</replaceable>
-	</arg>
-      </group>
-    </cmdsynopsis>
-    <cmdsynopsis>
-      <command>&COMMANDNAME;</command>
-      <group choice="req">
-	<arg choice="plain"><option>--is-enabled</option></arg>
-	<arg choice="plain"><option>-V</option></arg>
-      </group>
-      <arg choice='plain'><replaceable>CLIENT</replaceable></arg>
-    </cmdsynopsis>
-    <cmdsynopsis>
-      <command>&COMMANDNAME;</command>
-      <group choice="req">
-	<arg choice="plain"><option>--help</option></arg>
-	<arg choice="plain"><option>-h</option></arg>
-      </group>
-    </cmdsynopsis>
-    <cmdsynopsis>
-      <command>&COMMANDNAME;</command>
-      <group choice="req">
-	<arg choice="plain"><option>--version</option></arg>
-	<arg choice="plain"><option>-v</option></arg>
-      </group>
-    </cmdsynopsis>
-  </refsynopsisdiv>
-  
-  <refsect1 id="description">
-    <title>DESCRIPTION</title>
-    <para>
-      <command>&COMMANDNAME;</command> is a program to control the
-      operation of the Mandos server <citerefentry><refentrytitle
-      >mandos</refentrytitle><manvolnum>8</manvolnum></citerefentry>.
-    </para>
-    <para>
-      This program can be used to change client settings, approve or
-      deny client requests, and to remove clients from the server.
-    </para>
-  </refsect1>
-  
-  <refsect1 id="purpose">
-    <title>PURPOSE</title>
-    <para>
-      The purpose of this is to enable <emphasis>remote and unattended
-      rebooting</emphasis> of client host computer with an
-      <emphasis>encrypted root file system</emphasis>.  See <xref
-      linkend="overview"/> for details.
-    </para>
-  </refsect1>
-  
-  <refsect1 id="options">
-    <title>OPTIONS</title>
-    
-    <variablelist>
-      <varlistentry>
-	<term><option>--help</option></term>
-	<term><option>-h</option></term>
-	<listitem>
-	  <para>
-	    Show a help message and exit
-	  </para>
-	</listitem>
-      </varlistentry>
-      
-      <varlistentry>
-	<term><option>--enable</option></term>
-	<term><option>-e</option></term>
-	<listitem>
-	  <para>
-	    Enable client(s).  An enabled client will be eligble to
-	    receive its secret.
-	  </para>
-	</listitem>
-      </varlistentry>
-      
-      <varlistentry>
-	<term><option>--disable</option></term>
-	<term><option>-d</option></term>
-	<listitem>
-	  <para>
-	    Disable client(s).  A disabled client will not be eligble
-	    to receive its secret, and no checkers will be started for
-	    it.
-	  </para>
-	</listitem>
-      </varlistentry>
-      
-      <varlistentry>
-	<term><option>--bump-timeout</option></term>
-	<listitem>
-	  <para>
-	    Bump the timeout of the specified client(s), just as if a
-	    checker had completed successfully for it/them.
-	  </para>
-	</listitem>
-      </varlistentry>
-      
-      <varlistentry>
-	<term><option>--start-checker</option></term>
-	<listitem>
-	  <para>
-	    Start a new checker now for the specified client(s).
-	  </para>
-	</listitem>
-      </varlistentry>
-      
-      <varlistentry>
-	<term><option>--stop-checker</option></term>
-	<listitem>
-	  <para>
-	    Stop any running checker for the specified client(s).
-	  </para>
-	</listitem>
-      </varlistentry>
-      
-      <varlistentry>
-	<term><option>--remove</option></term>
-	<term><option>-r</option></term>
-	<listitem>
-	  <para>
-	    Remove the specified client(s) from the server.
-	  </para>
-	</listitem>
-      </varlistentry>
-      
-      <varlistentry>
-	<term><option>--checker
-	<replaceable>COMMAND</replaceable></option></term>
-	<term><option>-c
-	<replaceable>COMMAND</replaceable></option></term>
-	<listitem>
-	  <para>
-	    Set the <varname>checker</varname> option of the specified
-	    client(s); see <citerefentry><refentrytitle
-	    >mandos-clients.conf</refentrytitle><manvolnum
-            >5</manvolnum></citerefentry>.
-	  </para>
-	</listitem>
-      </varlistentry>
-      
-      <varlistentry>
-	<term><option>--timeout
-	<replaceable>TIME</replaceable></option></term>
-	<term><option>-t
-	<replaceable>TIME</replaceable></option></term>
-	<listitem>
-	  <para>
-	    Set the <varname>timeout</varname> option of the specified
-	    client(s); see <citerefentry><refentrytitle
-	    >mandos-clients.conf</refentrytitle><manvolnum
-            >5</manvolnum></citerefentry>.
-	  </para>
-	</listitem>
-      </varlistentry>
-      
-      <varlistentry>
-	<term><option>--interval
-	<replaceable>TIME</replaceable></option></term>
-	<term><option>-i
-	<replaceable>TIME</replaceable></option></term>
-	<listitem>
-	  <para>
-	    Set the <varname>interval</varname> option of the
-	    specified client(s); see <citerefentry><refentrytitle
-	    >mandos-clients.conf</refentrytitle><manvolnum
-            >5</manvolnum></citerefentry>.
-	  </para>
-	</listitem>
-      </varlistentry>
-      
-      <varlistentry>
-	<term><option>--approve-by-default</option></term>
-	<term><option>--deny-by-default</option></term>
-	<listitem>
-	  <para>
-	    Set the <varname>approved_by_default</varname> option of
-	    the specified client(s) to <literal>True</literal> or
-	    <literal>False</literal>, respectively; see
-	    <citerefentry><refentrytitle
-            >mandos-clients.conf</refentrytitle><manvolnum
-            >5</manvolnum></citerefentry>.
-	  </para>
-	</listitem>
-      </varlistentry>
-      
-      <varlistentry>
-	<term><option>--approval-delay
-	<replaceable>TIME</replaceable></option></term>
-	<listitem>
-	  <para>
-	    Set the <varname>approval_delay</varname> option of the
-	    specified client(s); see <citerefentry><refentrytitle
-	    >mandos-clients.conf</refentrytitle><manvolnum
-            >5</manvolnum></citerefentry>.
-	  </para>
-	</listitem>
-      </varlistentry>
-      
-      <varlistentry>
-	<term><option>--approval-duration
-	<replaceable>TIME</replaceable></option></term>
-	<listitem>
-	  <para>
-	    Set the <varname>approval_duration</varname> option of the
-	    specified client(s); see <citerefentry><refentrytitle
-	    >mandos-clients.conf</refentrytitle><manvolnum
-            >5</manvolnum></citerefentry>.
-	  </para>
-	</listitem>
-      </varlistentry>
-      
-      <varlistentry>
-	<term><option>--host
-	<replaceable>STRING</replaceable></option></term>
-	<term><option>-H
-	<replaceable>STRING</replaceable></option></term>
-	<listitem>
-	  <para>
-	    Set the <varname>host</varname> option of the specified
-	    client(s); see <citerefentry><refentrytitle
-	    >mandos-clients.conf</refentrytitle><manvolnum
-            >5</manvolnum></citerefentry>.
-	  </para>
-	</listitem>
-      </varlistentry>
-      
-      <varlistentry>
-	<term><option>--secret
-	<replaceable>FILENAME</replaceable></option></term>
-	<term><option>-s
-	<replaceable>FILENAME</replaceable></option></term>
-	<listitem>
-	  <para>
-	    Set the <varname>secfile</varname> option of the specified
-	    client(s); see <citerefentry><refentrytitle
-	    >mandos-clients.conf</refentrytitle><manvolnum
-            >5</manvolnum></citerefentry>.
-	  </para>
-	</listitem>
-      </varlistentry>
-      
-      <varlistentry>
-	<term><option>--approve</option></term>
-	<term><option>-A</option></term>
-	<listitem>
-	  <para>
-	    Approve client(s) if currently waiting for approval.
-	  </para>
-	</listitem>
-      </varlistentry>
-      
-      <varlistentry>
-	<term><option>--deny</option></term>
-	<term><option>-D</option></term>
-	<listitem>
-	  <para>
-	    Deny client(s) if currently waiting for approval.
-	  </para>
-	</listitem>
-      </varlistentry>
-      
-      <varlistentry>
-	<term><option>--all</option></term>
-	<term><option>-a</option></term>
-	<listitem>
-	  <para>
-	    Make the client-modifying options modify <emphasis
-	    >all</emphasis> clients.
-	  </para>
-	</listitem>
-      </varlistentry>
-      
-      <varlistentry>
-	<term><option>--verbose</option></term>
-	<term><option>-v</option></term>
-	<listitem>
-	  <para>
-	    Show all client settings, not just a subset.
-	  </para>
-	</listitem>
-      </varlistentry>
-      
-      <varlistentry>
-	<term><option>--is-enabled</option></term>
-	<term><option>-V</option></term>
-	<listitem>
-	  <para>
-	    Check if a single client is enabled or not, and exit with
-	    a successful exit status only if the client is enabled.
-	  </para>
-	</listitem>
-      </varlistentry>
-      
-    </variablelist>
-  </refsect1>
-  
-  <refsect1 id="overview">
-    <title>OVERVIEW</title>
-    <xi:include href="overview.xml"/>
-    <para>
-      This program is a small utility to generate new OpenPGP keys for
-      new Mandos clients, and to generate sections for inclusion in
-      <filename>clients.conf</filename> on the server.
-    </para>
-  </refsect1>
-  
-  <refsect1 id="exit_status">
-    <title>EXIT STATUS</title>
-    <para>
-      If the <option>--is-enabled</option> option is used, the exit
-      status will be 0 only if the specified client is enabled.
-    </para>
-  </refsect1>
-  
-<!--   <refsect1 id="bugs"> -->
-<!--     <title>BUGS</title> -->
-<!--     <para> -->
-<!--     </para> -->
-<!--   </refsect1> -->
-  
-  <refsect1 id="example">
-    <title>EXAMPLE</title>
-    <informalexample>
-      <para>
-	To list all clients:
-      </para>
-      <para>
-	<userinput>&COMMANDNAME;</userinput>
-      </para>
-    </informalexample>
-    
-    <informalexample>
-      <para>
-	To list <emphasis>all</emphasis> settings for the clients
-        named <quote>foo1.example.org</quote> and <quote
-        >foo2.example.org</quote>:
-      </para>
-      <para>
-
-<!-- do not wrap this line -->
-<userinput>&COMMANDNAME; --verbose foo1.example.org foo2.example.org</userinput>
-
-      </para>
-    </informalexample>
-    
-    <informalexample>
-      <para>
-	To enable all clients:
-      </para>
-      <para>
-	<userinput>&COMMANDNAME; --enable --all</userinput>
-      </para>
-    </informalexample>
-    
-    <informalexample>
-      <para>
-	To change timeout and interval value for the clients
-        named <quote>foo1.example.org</quote> and <quote
-        >foo2.example.org</quote>:
-      </para>
-      <para>
-
-<!-- do not wrap this line -->
-<userinput>&COMMANDNAME; --timeout="5m" --interval="1m" foo1.example.org foo2.example.org</userinput>
-
-      </para>
-    </informalexample>
-    
-    <informalexample>
-      <para>
-	To approve all clients currently waiting for it:
-      </para>
-      <para>
-	<userinput>&COMMANDNAME; --approve --all</userinput>
-      </para>
-    </informalexample>
-  </refsect1>
-  
-  <refsect1 id="security">
-    <title>SECURITY</title>
-    <para>
-      This program must be permitted to access the Mandos server via
-      the D-Bus interface.  This normally requires the root user, but
-      could be configured otherwise by reconfiguring the D-Bus server.
-    </para>
-  </refsect1>
-  
-  <refsect1 id="see_also">
-    <title>SEE ALSO</title>
-    <para>
-      <citerefentry><refentrytitle>mandos</refentrytitle>
-      <manvolnum>8</manvolnum></citerefentry>,
-      <citerefentry><refentrytitle>mandos-clients.conf</refentrytitle>
-      <manvolnum>5</manvolnum></citerefentry>,
-      <citerefentry><refentrytitle>mandos-monitor</refentrytitle>
-      <manvolnum>8</manvolnum></citerefentry>
-    </para>
-  </refsect1>
-  
-</refentry>
-<!-- Local Variables: -->
-<!-- time-stamp-start: "<!ENTITY TIMESTAMP [\"']" -->
-<!-- time-stamp-end: "[\"']>" -->
-<!-- time-stamp-format: "%:y-%02m-%02d" -->
-<!-- End: -->

=== modified file 'mandos-keygen'
--- mandos-keygen	2010-10-02 17:23:41 +0000
+++ mandos-keygen	2010-09-13 06:19:45 +0000
@@ -2,8 +2,8 @@
 # 
 # Mandos key generator - create a new OpenPGP key for a Mandos client
 # 
-# Copyright © 2008-2010 Teddy Hogeborn
-# Copyright © 2008-2010 Björn Påhlsson
+# Copyright © 2008,2009 Teddy Hogeborn
+# Copyright © 2008,2009 Björn Påhlsson
 # 
 # This program is free software: you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -21,7 +21,7 @@
 # Contact the authors at <mandos@fukt.bsnet.se>.
 # 
 
-VERSION="1.2.1"
+VERSION="1.0.14"
 
 KEYDIR="/etc/keys/mandos"
 KEYTYPE=DSA
@@ -195,8 +195,6 @@
 stty echo; \
 " EXIT
 
-set -e
-
 umask 077
 
 if [ "$mode" = keygen ]; then

=== modified file 'mandos-monitor'
--- mandos-monitor	2010-10-02 17:23:41 +0000
+++ mandos-monitor	2010-09-14 18:22:03 +0000
@@ -1,26 +1,5 @@
 #!/usr/bin/python
 # -*- mode: python; coding: utf-8 -*-
-# 
-# Mandos Monitor - Control and monitor the Mandos server
-# 
-# Copyright © 2009,2010 Teddy Hogeborn
-# Copyright © 2009,2010 Björn Påhlsson
-# 
-# This program is free software: you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation, either version 3 of the License, or
-# (at your option) any later version.
-#
-#     This program is distributed in the hope that it will be useful,
-#     but WITHOUT ANY WARRANTY; without even the implied warranty of
-#     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-#     GNU General Public License for more details.
-# 
-# You should have received a copy of the GNU General Public License
-# along with this program.  If not, see <http://www.gnu.org/licenses/>.
-# 
-# Contact the authors at <mandos@fukt.bsnet.se>.
-# 
 
 from __future__ import division, absolute_import, with_statement
 
@@ -51,7 +30,7 @@
 domain = 'se.bsnet.fukt'
 server_interface = domain + '.Mandos'
 client_interface = domain + '.Mandos.Client'
-version = "1.2.1"
+version = "1.0.15"
 
 # Always run in monochrome mode
 urwid.curses_display.curses.has_colors = lambda : False
@@ -123,7 +102,6 @@
         self.logger = logger
         
         self._update_timer_callback_tag = None
-        self._update_timer_callback_lock = 0
         self.last_checker_failed = False
         
         # The widget shown normally
@@ -135,7 +113,26 @@
             *args, **kwargs)
         self.update()
         self.opened = False
-        
+        self.proxy.connect_to_signal(u"CheckerCompleted",
+                                     self.checker_completed,
+                                     client_interface,
+                                     byte_arrays=True)
+        self.proxy.connect_to_signal(u"CheckerStarted",
+                                     self.checker_started,
+                                     client_interface,
+                                     byte_arrays=True)
+        self.proxy.connect_to_signal(u"GotSecret",
+                                     self.got_secret,
+                                     client_interface,
+                                     byte_arrays=True)
+        self.proxy.connect_to_signal(u"NeedApproval",
+                                     self.need_approval,
+                                     client_interface,
+                                     byte_arrays=True)
+        self.proxy.connect_to_signal(u"Rejected",
+                                     self.rejected,
+                                     client_interface,
+                                     byte_arrays=True)
         last_checked_ok = isoformat_to_datetime(self.properties
                                                 [u"LastCheckedOK"])
         if last_checked_ok is None:
@@ -147,62 +144,17 @@
                                         (milliseconds=
                                          self.properties
                                          [u"Interval"]))
-        
         if self.last_checker_failed:
-            self.using_timer(True)
-        
-        if self.need_approval:
-            self.using_timer(True)
-        
-        self.proxy.connect_to_signal(u"CheckerCompleted",
-                                     self.checker_completed,
-                                     client_interface,
-                                     byte_arrays=True)
-        self.proxy.connect_to_signal(u"CheckerStarted",
-                                     self.checker_started,
-                                     client_interface,
-                                     byte_arrays=True)
-        self.proxy.connect_to_signal(u"GotSecret",
-                                     self.got_secret,
-                                     client_interface,
-                                     byte_arrays=True)
-        self.proxy.connect_to_signal(u"NeedApproval",
-                                     self.need_approval,
-                                     client_interface,
-                                     byte_arrays=True)
-        self.proxy.connect_to_signal(u"Rejected",
-                                     self.rejected,
-                                     client_interface,
-                                     byte_arrays=True)
-    
-    def property_changed(self, property=None, value=None):
-        super(self, MandosClientWidget).property_changed(property,
-                                                         value)
-        if property == u"ApprovalPending":
-            using_timer(bool(value))
-        
-    def using_timer(self, flag):
-        """Call this method with True or False when timer should be
-        activated or deactivated.
-        """
-        old = self._update_timer_callback_lock
-        if flag:
-            self._update_timer_callback_lock += 1
-        else:
-            self._update_timer_callback_lock -= 1
-        if old == 0 and self._update_timer_callback_lock:
             self._update_timer_callback_tag = (gobject.timeout_add
                                                (1000,
                                                 self.update_timer))
-        elif old and self._update_timer_callback_lock == 0:
-            gobject.source_remove(self._update_timer_callback_tag)
-            self._update_timer_callback_tag = None
     
     def checker_completed(self, exitstatus, condition, command):
         if exitstatus == 0:
             if self.last_checker_failed:
                 self.last_checker_failed = False
-                self.using_timer(False)
+                gobject.source_remove(self._update_timer_callback_tag)
+                self._update_timer_callback_tag = None
             #self.logger(u'Checker for client %s (command "%s")'
             #            u' was successful'
             #            % (self.properties[u"Name"], command))
@@ -211,7 +163,9 @@
         # Checker failed
         if not self.last_checker_failed:
             self.last_checker_failed = True
-            self.using_timer(True)
+            self._update_timer_callback_tag = (gobject.timeout_add
+                                               (1000,
+                                                self.update_timer))
         if os.WIFEXITED(condition):
             self.logger(u'Checker for client %s (command "%s")'
                         u' failed with exit code %s'
@@ -248,7 +202,6 @@
             message = u'Client %s will get its secret in %s seconds'
         self.logger(message
                     % (self.properties[u"Name"], timeout/1000))
-        self.using_timer(True)
     
     def rejected(self, reason):
         self.logger(u'Client %s was rejected; reason: %s'
@@ -289,21 +242,10 @@
         if not self.properties[u"Enabled"]:
             message = u"DISABLED"
         elif self.properties[u"ApprovalPending"]:
-            timeout = datetime.timedelta(milliseconds
-                                         = self.properties
-                                         [u"ApprovalDelay"])
-            last_approval_request = isoformat_to_datetime(
-                self.properties[u"LastApprovalRequest"])
-            if last_approval_request is not None:
-                timer = timeout - (datetime.datetime.utcnow()
-                                   - last_approval_request)
-            else:
-                timer = datetime.timedelta()
             if self.properties[u"ApprovedByDefault"]:
-                message = u"Approval in %s. (d)eny?"
+                message = u"Connection established to client. (d)eny?"
             else:
-                message = u"Denial in %s. (a)pprove?"
-            message = message % unicode(timer).rsplit(".", 1)[0]
+                message = u"Seeks approval to send secret. (a)pprove?"
         elif self.last_checker_failed:
             timeout = datetime.timedelta(milliseconds
                                          = self.properties
@@ -314,7 +256,7 @@
                     self.properties[u"LastEnabled"]))
             timer = timeout - (datetime.datetime.utcnow() - last_ok)
             message = (u'A checker has failed! Time until client'
-                       u' gets disabled: %s'
+                       u' gets diabled: %s'
                            % unicode(timer).rsplit(".", 1)[0])
         else:
             message = u"enabled"
@@ -367,7 +309,7 @@
         elif key == u"d":
             self.proxy.Approve(dbus.Boolean(False, variant_level=1),
                                   dbus_interface = client_interface)
-        elif key == u"R" or key == u"_" or key == u"ctrl k":
+        elif key == u"r" or key == u"_" or key == u"ctrl k":
             self.server_proxy_object.RemoveClient(self.proxy
                                                   .object_path)
         elif key == u"s":
@@ -686,7 +628,7 @@
                                       .join((u"Clients:",
                                              u"+: Enable",
                                              u"-: Disable",
-                                             u"R: Remove",
+                                             u"r: Remove",
                                              u"s: Start new checker",
                                              u"S: Stop checker",
                                              u"C: Checker OK",

=== modified file 'mandos-monitor.xml'
--- mandos-monitor.xml	2010-09-30 06:24:20 +0000
+++ mandos-monitor.xml	2010-09-14 18:22:03 +0000
@@ -167,7 +167,7 @@
 	<entry>Deny client</entry>
       </row>
       <row>
-	<entry>R, _, Ctrl-K</entry>
+	<entry>r, _, Ctrl-K</entry>
 	<entry>Remove client</entry>
       </row>
       <row>

=== modified file 'mandos.lsm'
--- mandos.lsm	2010-10-02 17:23:41 +0000
+++ mandos.lsm	2010-09-14 18:22:03 +0000
@@ -1,7 +1,7 @@
 Begin4
 Title:		Mandos
-Version:	1.2.1
-Entered-date:	2010-10-02
+Version:	1.0.14
+Entered-date:	2010-09-14
 Description:	The Mandos system allows computers to have encrypted
 root file systems and at the same time be capable of remote and/or
 unattended reboots.
@@ -12,9 +12,9 @@
 Maintained-by:	teddy@fukt.bsnet.se (Teddy Hogeborn),
 		belorn@fukt.bsnet.se (Björn Påhlsson)
 Primary-site: http://www.fukt.bsnet.se/mandos
-	      130K mandos_1.2.1.orig.tar.gz
+	      103K mandos_1.0.14.orig.tar.gz
 Alternate-site: ftp://ftp.fukt.bsnet.se/pub/mandos
-		130K mandos_1.2.1.orig.tar.gz
+		103K mandos_1.0.14.orig.tar.gz
 Platforms:	Requires GCC, GNU libC, Avahi, GnuPG, Python 2.5, and
 various other libraries.  While made for Debian GNU/Linux, it is
 probably portable to other distributions, but not other Unixes.

=== modified file 'mandos.xml'
--- mandos.xml	2010-09-27 17:39:03 +0000
+++ mandos.xml	2010-09-12 03:00:40 +0000
@@ -2,7 +2,7 @@
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 "http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY COMMANDNAME "mandos">
-<!ENTITY TIMESTAMP "2010-09-26">
+<!ENTITY TIMESTAMP "2010-09-11">
 <!ENTITY % common SYSTEM "common.ent">
 %common;
 ]>
@@ -33,7 +33,6 @@
     <copyright>
       <year>2008</year>
       <year>2009</year>
-      <year>2010</year>
       <holder>Teddy Hogeborn</holder>
       <holder>Björn Påhlsson</holder>
     </copyright>
@@ -87,9 +86,6 @@
       <sbr/>
       <arg><option>--debug</option></arg>
       <sbr/>
-      <arg><option>--debuglevel
-      <replaceable>LEVEL</replaceable></option></arg>
-      <sbr/>
       <arg><option>--no-dbus</option></arg>
       <sbr/>
       <arg><option>--no-ipv6</option></arg>
@@ -198,24 +194,6 @@
       </varlistentry>
       
       <varlistentry>
-	<term><option>--debuglevel
-	<replaceable>LEVEL</replaceable></option></term>
-	<listitem>
-	  <para>
-	    Set the debugging log level.
-	    <replaceable>LEVEL</replaceable> is a string, one of
-	    <quote><literal>CRITICAL</literal></quote>,
-	    <quote><literal>ERROR</literal></quote>,
-	    <quote><literal>WARNING</literal></quote>,
-	    <quote><literal>INFO</literal></quote>, or
-	    <quote><literal>DEBUG</literal></quote>, in order of
-	    increasing verbosity.  The default level is
-	    <quote><literal>WARNING</literal></quote>.
-	  </para>
-	</listitem>
-      </varlistentry>
-      
-      <varlistentry>
 	<term><option>--priority <replaceable>
 	PRIORITY</replaceable></option></term>
 	<listitem>
@@ -360,26 +338,6 @@
     </para>
   </refsect1>
   
-  <refsect1 id="approval">
-    <title>APPROVAL</title>
-    <para>
-      The server can be configured to require manual approval for a
-      client before it is sent its secret.  The delay to wait for such
-      approval and the default action (approve or deny) can be
-      configured both globally and per client; see <citerefentry>
-      <refentrytitle>mandos-clients.conf</refentrytitle>
-      <manvolnum>5</manvolnum></citerefentry>.  By default all clients
-      will be approved immediately without delay.
-    </para>
-    <para>
-      This can be used to deny a client its secret if not manually
-      approved within a specified time.  It can also be used to make
-      the server delay before giving a client its secret, allowing
-      optional manual denying of this specific client.
-    </para>
-    
-  </refsect1>
-  
   <refsect1 id="logging">
     <title>LOGGING</title>
     <para>
@@ -460,8 +418,8 @@
 	<term><filename>/var/run/mandos.pid</filename></term>
 	<listitem>
 	  <para>
-	    The file containing the process id of the
-	    <command>&COMMANDNAME;</command> process started last.
+	    The file containing the process id of
+	    <command>&COMMANDNAME;</command>.
 	  </para>
 	</listitem>
       </varlistentry>

=== modified file 'plugin-runner.c'
--- plugin-runner.c	2010-09-26 21:27:28 +0000
+++ plugin-runner.c	2010-09-09 22:06:10 +0000
@@ -2,8 +2,8 @@
 /*
  * Mandos plugin runner - Run Mandos plugins
  *
- * Copyright © 2008-2010 Teddy Hogeborn
- * Copyright © 2008-2010 Björn Påhlsson
+ * Copyright © 2008,2009 Teddy Hogeborn
+ * Copyright © 2008,2009 Björn Påhlsson
  * 
  * This program is free software: you can redistribute it and/or
  * modify it under the terms of the GNU General Public License as

=== modified file 'plugins.d/askpass-fifo.c'
--- plugins.d/askpass-fifo.c	2010-09-26 18:32:58 +0000
+++ plugins.d/askpass-fifo.c	2010-09-07 16:48:58 +0000
@@ -2,8 +2,8 @@
 /*
  * Askpass-FIFO - Read a password from a FIFO and output it
  * 
- * Copyright © 2008-2010 Teddy Hogeborn
- * Copyright © 2008-2010 Björn Påhlsson
+ * Copyright © 2008,2009 Teddy Hogeborn
+ * Copyright © 2008,2009 Björn Påhlsson
  * 
  * This program is free software: you can redistribute it and/or
  * modify it under the terms of the GNU General Public License as

=== modified file 'plugins.d/mandos-client.c'
--- plugins.d/mandos-client.c	2010-09-26 21:27:28 +0000
+++ plugins.d/mandos-client.c	2010-09-12 18:12:11 +0000
@@ -9,8 +9,8 @@
  * "browse_callback", and parts of "main".
  * 
  * Everything else is
- * Copyright © 2008-2010 Teddy Hogeborn
- * Copyright © 2008-2010 Björn Påhlsson
+ * Copyright © 2008,2009 Teddy Hogeborn
+ * Copyright © 2008,2009 Björn Påhlsson
  * 
  * This program is free software: you can redistribute it and/or
  * modify it under the terms of the GNU General Public License as

=== modified file 'plugins.d/mandos-client.xml'
--- plugins.d/mandos-client.xml	2010-09-26 18:32:58 +0000
+++ plugins.d/mandos-client.xml	2010-08-10 19:08:24 +0000
@@ -2,7 +2,7 @@
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY COMMANDNAME "mandos-client">
-<!ENTITY TIMESTAMP "2010-09-26">
+<!ENTITY TIMESTAMP "2009-02-09">
 <!ENTITY % common SYSTEM "../common.ent">
 %common;
 ]>

=== modified file 'plugins.d/password-prompt.c'
--- plugins.d/password-prompt.c	2010-11-05 18:30:07 +0000
+++ plugins.d/password-prompt.c	2010-09-07 16:48:58 +0000
@@ -2,8 +2,8 @@
 /*
  * Password-prompt - Read a password from the terminal and print it
  * 
- * Copyright © 2008-2010 Teddy Hogeborn
- * Copyright © 2008-2010 Björn Påhlsson
+ * Copyright © 2008,2009 Teddy Hogeborn
+ * Copyright © 2008,2009 Björn Påhlsson
  * 
  * This program is free software: you can redistribute it and/or
  * modify it under the terms of the GNU General Public License as
@@ -22,23 +22,22 @@
  * Contact the authors at <mandos@fukt.bsnet.se>.
  */
 
-#define _GNU_SOURCE		/* getline(), asprintf() */
+#define _GNU_SOURCE		/* getline() */
 
 #include <termios.h> 		/* struct termios, tcsetattr(),
 				   TCSAFLUSH, tcgetattr(), ECHO */
 #include <unistd.h>		/* struct termios, tcsetattr(),
 				   STDIN_FILENO, TCSAFLUSH,
-				   tcgetattr(), ECHO, readlink() */
+				   tcgetattr(), ECHO */
 #include <signal.h>		/* sig_atomic_t, raise(), struct
 				   sigaction, sigemptyset(),
 				   sigaction(), sigaddset(), SIGINT,
 				   SIGQUIT, SIGHUP, SIGTERM,
 				   raise() */
 #include <stddef.h>		/* NULL, size_t, ssize_t */
-#include <sys/types.h>		/* ssize_t, struct dirent, pid_t, ssize_t */
+#include <sys/types.h>		/* ssize_t */
 #include <stdlib.h>		/* EXIT_SUCCESS, EXIT_FAILURE,
-				   getenv(), free() */
-#include <dirent.h>		/* scandir(), alphasort() */
+				   getenv() */
 #include <stdio.h>		/* fprintf(), stderr, getline(),
 				   stdin, feof(), fputc()
 				*/
@@ -48,9 +47,7 @@
 #include <error.h>		/* error() */
 #include <iso646.h>		/* or, not */
 #include <stdbool.h>		/* bool, false, true */
-#include <inttypes.h>		/* strtoumax() */
-#include <sys/stat.h> 		/* struct stat, lstat() */
-#include <string.h> 		/* strlen, rindex, memcmp */
+#include <string.h> 		/* strlen, rindex */
 #include <argp.h>		/* struct argp_option, struct
 				   argp_state, struct argp,
 				   argp_parse(), error_t,
@@ -65,10 +62,6 @@
 const char *argp_program_version = "password-prompt " VERSION;
 const char *argp_program_bug_address = "<mandos@fukt.bsnet.se>";
 
-/* Needed for conflic resolution */
-const char plymouthd_path[] = "/sbin/plymouth";
-
-
 static void termination_handler(int signum){
   if(quit_now){
     return;
@@ -77,74 +70,6 @@
   signal_received = signum;
 }
 
-bool conflict_detection(void){
-
-  /* plymouth conflicts with password-promt since both want to control the
-     associated terminal. Password-prompt exit since plymouth perferms the same
-     functionallity.
-   */
-  int is_plymouth(const struct dirent *proc_entry){
-    int ret;
-    {
-      uintmax_t maxvalue;
-      char *tmp;
-      errno = 0;
-      maxvalue = strtoumax(proc_entry->d_name, &tmp, 10);
-      
-      if(errno != 0 or *tmp != '\0'
-	 or maxvalue != (uintmax_t)((pid_t)maxvalue)){
-	return 0;
-      }
-    }
-    char exe_target[sizeof(plymouthd_path)];
-    char *exe_link;
-    ret = asprintf(&exe_link, "/proc/%s/exe", proc_entry->d_name);
-    if(ret == -1){
-      error(0, errno, "asprintf");
-      return 0;
-    }
-  
-    struct stat exe_stat;
-    ret = lstat(exe_link, &exe_stat);
-    if(ret == -1){
-      free(exe_link);
-      if(errno != ENOENT){
-	error(0, errno, "lstat");
-      }
-      return 0;
-    }
-  
-    if(not S_ISLNK(exe_stat.st_mode)
-       or exe_stat.st_uid != 0
-       or exe_stat.st_gid != 0){
-      free(exe_link);
-      return 0;
-    }
-  
-    ssize_t sret = readlink(exe_link, exe_target, sizeof(exe_target));
-    free(exe_link);
-    if((sret != (ssize_t)sizeof(plymouthd_path)-1) or
-       (memcmp(plymouthd_path, exe_target,
-	       sizeof(plymouthd_path)-1) != 0)){
-      return 0;
-    }
-    return 1;
-  }
-
-  struct dirent **direntries;
-  int ret;
-  ret = scandir("/proc", &direntries, is_plymouth, alphasort);
-  if (ret == -1){
-    error(1, errno, "scandir");
-  }
-  if (ret < 0){
-    return 1;
-  } else {
-    return 0;
-  }
-}
-
-
 int main(int argc, char **argv){
   ssize_t sret;
   int ret;
@@ -226,14 +151,6 @@
   if(debug){
     fprintf(stderr, "Starting %s\n", argv[0]);
   }
-
-  if (conflict_detection()){
-    if(debug){
-      fprintf(stderr, "Stopping %s because of conflict", argv[0]);
-    }
-    return EXIT_FAILURE;
-  }
-  
   if(debug){
     fprintf(stderr, "Storing current terminal attributes\n");
   }

=== modified file 'plugins.d/plymouth.c'
--- plugins.d/plymouth.c	2010-11-05 18:30:07 +0000
+++ plugins.d/plymouth.c	2010-09-15 17:21:04 +0000
@@ -1,27 +1,3 @@
-/*  -*- coding: utf-8 -*- */
-/*
- * Usplash - Read a password from usplash and output it
- * 
- * Copyright © 2010 Teddy Hogeborn
- * Copyright © 2010 Björn Påhlsson
- * 
- * This program is free software: you can redistribute it and/or
- * modify it under the terms of the GNU General Public License as
- * published by the Free Software Foundation, either version 3 of the
- * License, or (at your option) any later version.
- * 
- * This program is distributed in the hope that it will be useful, but
- * WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
- * General Public License for more details.
- * 
- * You should have received a copy of the GNU General Public License
- * along with this program.  If not, see
- * <http://www.gnu.org/licenses/>.
- * 
- * Contact the authors at <mandos@fukt.bsnet.se>.
- */
-
 #define _GNU_SOURCE		/* asprintf(), TEMP_FAILURE_RETRY() */
 #include <signal.h>		/* sig_atomic_t, struct sigaction,
 				   sigemptyset(), sigaddset(), SIGINT,
@@ -30,15 +6,14 @@
 #include <stdbool.h>		/* bool, false, true */
 #include <fcntl.h>		/* open(), O_RDONLY */
 #include <iso646.h>		/* and, or, not*/
-#include <sys/types.h>		/* size_t, ssize_t, pid_t, struct
-				   dirent, waitpid() */
+#include <sys/types.h>		/* size_t, ssize_t, pid_t, struct dirent,
+				   waitpid() */
 #include <sys/wait.h>		/* waitpid() */
 #include <stddef.h>		/* NULL */
 #include <string.h>		/* strchr(), memcmp() */
-#include <stdio.h>		/* asprintf(), perror(), fopen(),
-				   fscanf() */
-#include <unistd.h>		/* close(), readlink(), read(),
-				   fork(), setsid(), chdir(), dup2(),
+#include <stdio.h>		/* asprintf(), perror(), fopen(), fscanf() */
+#include <unistd.h>		/* close(), readlink(), read(), fork()
+				   setsid(), chdir(), dup2()
 				   STDERR_FILENO, execv(), access() */
 #include <stdlib.h>		/* free(), EXIT_FAILURE, realloc(),
 				   EXIT_SUCCESS, malloc(), _exit(),
@@ -46,7 +21,7 @@
 #include <dirent.h>		/* scandir(), alphasort() */
 #include <inttypes.h>		/* intmax_t, strtoumax(), SCNuMAX */
 #include <sys/stat.h>		/* struct stat, lstat() */
-#include <sysexits.h>		/* EX_OSERR, EX_UNAVAILABLE */
+#include <sysexits.h>		/* EX_OSERR */
 #include <error.h>		/* error() */
 #include <errno.h>		/* TEMP_FAILURE_RETRY */
 #include <argz.h>		/* argz_count(), argz_extract() */
@@ -55,12 +30,9 @@
 const char plymouth_pid[] = "/dev/.initramfs/plymouth.pid";
 const char plymouth_path[] = "/bin/plymouth";
 const char plymouthd_path[] = "/sbin/plymouthd";
-const char *plymouthd_default_argv[] = {"/sbin/plymouthd",
-					"--mode=boot",
+const char *plymouthd_default_argv[] = {"/sbin/plymouthd", "--mode=boot",
 					"--attach-to-session",
-					"--pid-file="
-					"/dev/.initramfs/"
-					"plymouth.pid",
+					"--pid-file=/dev/.initramfs/plymouth.pid",
 					NULL };
 
 static void termination_handler(__attribute__((unused))int signum){
@@ -151,7 +123,7 @@
       if (tmp == NULL){
 	error(0, errno, "realloc");
 	free(new_argv);
-	_exit(EX_OSERR);
+	_exit(EXIT_FAILURE);
       }
       new_argv = (char **)tmp;
       new_argv[i] = strdup(argv[i]);
@@ -177,7 +149,7 @@
     error(0, errno, "waitpid");
     return false;
   }
-  if(WIFEXITED(status) and (WEXITSTATUS(status) == 0)){
+  if(WIFEXITED(status) and WEXITSTATUS(status) == 0){
     return true;
   }
   return false;
@@ -191,19 +163,18 @@
     errno = 0;
     maxvalue = strtoumax(proc_entry->d_name, &tmp, 10);
 
-    if(errno != 0 or *tmp != '\0'
-       or maxvalue != (uintmax_t)((pid_t)maxvalue)){
+    if(errno != 0 or *tmp != '\0' or maxvalue != (uintmax_t)((pid_t)maxvalue)){
       return 0;
     }
   }
-  char exe_target[sizeof(plymouthd_path)];
+  char exe_target[sizeof(plymouth_path)];
   char *exe_link;
   ret = asprintf(&exe_link, "/proc/%s/exe", proc_entry->d_name);
   if(ret == -1){
     error(0, errno, "asprintf");
     return 0;
   }
-  
+
   struct stat exe_stat;
   ret = lstat(exe_link, &exe_stat);
   if(ret == -1){
@@ -220,12 +191,12 @@
     free(exe_link);
     return 0;
   }
-  
+
   ssize_t sret = readlink(exe_link, exe_target, sizeof(exe_target));
   free(exe_link);
-  if((sret != (ssize_t)sizeof(plymouthd_path)-1) or
-      (memcmp(plymouthd_path, exe_target,
-	      sizeof(plymouthd_path)-1) != 0)){
+  if((sret != (ssize_t)sizeof(plymouth_path)-1) or
+      (memcmp(plymouth_path, exe_target,
+	      sizeof(plymouth_path)-1) != 0)){
     return 0;
   }
   return 1;
@@ -245,15 +216,7 @@
   if(maxvalue == 0){
     struct dirent **direntries;
     ret = scandir("/proc", &direntries, is_plymouth, alphasort);
-    if (ret == -1){
-      error(0, errno, "scandir");
-    }
-    if (ret > 0){
-      ret = sscanf(direntries[0]->d_name, "%" SCNuMAX, &maxvalue);
-      if (ret < 0){
-	error(0, errno, "sscanf");
-      }
-    }
+    sscanf(direntries[0]->d_name, "%" SCNuMAX, &maxvalue);
   }
   pid_t pid;
   pid = (pid_t)maxvalue;
@@ -345,95 +308,92 @@
   /* test -x /bin/plymouth */
   ret = access(plymouth_path, X_OK);
   if(ret == -1){
-    /* Plymouth is probably not installed.  Don't print an error
-       message, just exit. */
-    exit(EX_UNAVAILABLE);
+    exit(EXIT_FAILURE);
   }
-  
+
   { /* Add signal handlers */
     struct sigaction old_action,
       new_action = { .sa_handler = termination_handler,
 		     .sa_flags = 0 };
     sigemptyset(&new_action.sa_mask);
-    for(int *sig = (int[]){ SIGINT, SIGHUP, SIGTERM, 0 };
-	*sig != 0; sig++){
+    for(int *sig = (int[]){ SIGINT, SIGHUP, SIGTERM, 0 }; *sig != 0; sig++){
       ret = sigaddset(&new_action.sa_mask, *sig);
       if(ret == -1){
-	error(EX_OSERR, errno, "sigaddset");
+	error(0, errno, "sigaddset");
+	exit(EX_OSERR);
       }
       ret = sigaction(*sig, NULL, &old_action);
       if(ret == -1){
-	error(EX_OSERR, errno, "sigaction");
+	error(0, errno, "sigaction");
+	exit(EX_OSERR);
       }
       if(old_action.sa_handler != SIG_IGN){
 	ret = sigaction(*sig, &new_action, NULL);
 	if(ret == -1){
-	  error(EX_OSERR, errno, "sigaction");
+	  error(0, errno, "sigaction");
+	  exit(EX_OSERR);
 	}
       }
     }
   }
-  
+    
   /* plymouth --ping */
   bret = exec_and_wait(&plymouth_command_pid, plymouth_path,
-		       (const char *[])
-		       { plymouth_path, "--ping", NULL },
+		       (const char *[]){ (const char *)plymouth_path, (const char *)"--ping", (const char *)NULL},
 		       true, false);
   if(not bret){
     if(interrupted_by_signal){
       kill_and_wait(plymouth_command_pid);
-      exit(EXIT_FAILURE);
     }
-    /* Plymouth is probably not running.  Don't print an error
-       message, just exit. */
-    exit(EX_UNAVAILABLE);
+    exit(EXIT_FAILURE);
   }
   
   prompt = makeprompt();
   ret = asprintf(&prompt_arg, "--prompt=%s", prompt);
   free(prompt);
   if(ret == -1){
-    error(EX_OSERR, errno, "asprintf");
+    error(0, errno, "asprintf");
+    exit(EXIT_FAILURE);
   }
   
   /* plymouth ask-for-password --prompt="$prompt" */
-  bret = exec_and_wait(&plymouth_command_pid,
-		       plymouth_path, (const char *[])
-		       { plymouth_path, "ask-for-password",
-			   prompt_arg, NULL },
+  bret = exec_and_wait(&plymouth_command_pid, plymouth_path,
+		       (const char *[]){plymouth_path, "ask-for-password", prompt_arg, NULL},
 		       true, false);
   free(prompt_arg);
+  if(not bret){
+    if(interrupted_by_signal){
+      kill_and_wait(plymouth_command_pid);
+    } else {
+      exit(EXIT_FAILURE);
+    }
+  }
+  
   if(bret){
     exit(EXIT_SUCCESS);
   }
-  if(not interrupted_by_signal){
-    /* exec_and_wait failed for some other reason */
-    exit(EXIT_FAILURE);
-  }
-  kill_and_wait(plymouth_command_pid);
   
-  const char **plymouthd_argv;
+  const char **plymouthd_argv = NULL;
   pid_t pid = get_pid();
   if(pid == 0){
     error(0, 0, "plymouthd pid not found");
+  } else {
+    plymouthd_argv = getargv(pid);
+  }
+  if(plymouthd_argv == NULL){
     plymouthd_argv = plymouthd_default_argv;
-  } else {
-    plymouthd_argv = getargv(pid);
   }
   
-  bret = exec_and_wait(NULL, plymouth_path, (const char *[])
-		       { plymouth_path, "quit", NULL },
-		       false, false);
-  if(not bret){
-    exit(EXIT_FAILURE);
-  }
-  bret = exec_and_wait(NULL, plymouthd_path, plymouthd_argv,
-		       false, true);
-  if(not bret){
-    exit(EXIT_FAILURE);
-  }
-  exec_and_wait(NULL, plymouth_path, (const char *[])
-		{ plymouth_path, "show-splash", NULL },
-		false, false);
+  bret = exec_and_wait(NULL, plymouth_path,
+  		       (const char *[]){plymouth_path, "quit", NULL}, false, false);
+  if(not bret){
+    exit(EXIT_FAILURE);
+  }
+  bret = exec_and_wait(NULL, plymouthd_path, plymouthd_argv, false, true);
+  if(not bret){
+    exit(EXIT_FAILURE);
+  }
+  exec_and_wait(NULL, plymouth_path,
+  		(const char *[]){ plymouth_path, "show-splash", NULL }, false, false);
   exit(EXIT_FAILURE);
 }

=== removed file 'plugins.d/plymouth.xml'
--- plugins.d/plymouth.xml	2010-09-26 18:32:58 +0000
+++ plugins.d/plymouth.xml	1970-01-01 00:00:00 +0000
@@ -1,278 +0,0 @@
-<?xml version="1.0" encoding="UTF-8"?>
-<!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
-	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
-<!ENTITY COMMANDNAME "plymouth">
-<!ENTITY TIMESTAMP "2010-09-26">
-<!ENTITY % common SYSTEM "../common.ent">
-%common;
-]>
-
-<refentry xmlns:xi="http://www.w3.org/2001/XInclude">
-  <refentryinfo>
-    <title>Mandos Manual</title>
-    <!-- NWalsh’s docbook scripts use this to generate the footer: -->
-    <productname>Mandos</productname>
-    <productnumber>&version;</productnumber>
-    <date>&TIMESTAMP;</date>
-    <authorgroup>
-      <author>
-	<firstname>Björn</firstname>
-	<surname>Påhlsson</surname>
-	<address>
-	  <email>belorn@fukt.bsnet.se</email>
-	</address>
-      </author>
-      <author>
-	<firstname>Teddy</firstname>
-	<surname>Hogeborn</surname>
-	<address>
-	  <email>teddy@fukt.bsnet.se</email>
-	</address>
-      </author>
-    </authorgroup>
-    <copyright>
-      <year>2010</year>
-      <holder>Teddy Hogeborn</holder>
-      <holder>Björn Påhlsson</holder>
-    </copyright>
-    <xi:include href="../legalnotice.xml"/>
-  </refentryinfo>
-  
-  <refmeta>
-    <refentrytitle>&COMMANDNAME;</refentrytitle>
-    <manvolnum>8mandos</manvolnum>
-  </refmeta>
-  
-  <refnamediv>
-    <refname><command>&COMMANDNAME;</command></refname>
-    <refpurpose>Mandos plugin to use plymouth to get a
-    password.</refpurpose>
-  </refnamediv>
-  
-  <refsynopsisdiv>
-    <cmdsynopsis>
-      <command>&COMMANDNAME;</command>
-    </cmdsynopsis>
-  </refsynopsisdiv>
-  
-  <refsect1 id="description">
-    <title>DESCRIPTION</title>
-    <para>
-      This program prompts for a password using <citerefentry>
-      <refentrytitle>plymouth</refentrytitle><manvolnum>8</manvolnum>
-      </citerefentry> and outputs any given password to standard
-      output.  If no <citerefentry><refentrytitle
-      >plymouth</refentrytitle><manvolnum>8</manvolnum></citerefentry>
-      process can be found, this program will immediately exit with an
-      exit code indicating failure.
-    </para>
-    <para>
-      This program is not very useful on its own.  This program is
-      really meant to run as a plugin in the <application
-      >Mandos</application> client-side system, where it is used as a
-      fallback and alternative to retrieving passwords from a
-      <application >Mandos</application> server.
-    </para>
-    <para>
-      If this program is killed (presumably by
-      <citerefentry><refentrytitle>plugin-runner</refentrytitle>
-      <manvolnum>8mandos</manvolnum></citerefentry> because some other
-      plugin provided the password), it cannot tell <citerefentry>
-      <refentrytitle>plymouth</refentrytitle><manvolnum>8</manvolnum>
-      </citerefentry> to abort requesting a password, because
-      <citerefentry><refentrytitle>plymouth</refentrytitle>
-      <manvolnum>8</manvolnum></citerefentry> does not support this.
-      Therefore, this program will then <emphasis>kill</emphasis> the
-      running <citerefentry><refentrytitle>plymouth</refentrytitle>
-      <manvolnum>8</manvolnum></citerefentry> process and start a
-      <emphasis>new</emphasis> one using the same command line
-      arguments as the old one was using.
-    </para>
-  </refsect1>
-  
-  <refsect1 id="options">
-    <title>OPTIONS</title>
-    <para>
-      This program takes no options.
-    </para>
-  </refsect1>
-  
-  <refsect1 id="exit_status">
-    <title>EXIT STATUS</title>
-    <para>
-      If exit status is 0, the output from the program is the password
-      as it was read.  Otherwise, if exit status is other than 0, the
-      program was interrupted or encountered an error, and any output
-      so far could be corrupt and/or truncated, and should therefore
-      be ignored.
-    </para>
-  </refsect1>
-  
-  <refsect1 id="environment">
-    <title>ENVIRONMENT</title>
-    <variablelist>
-      <varlistentry>
-	<term><envar>cryptsource</envar></term>
-	<term><envar>crypttarget</envar></term>
-	<listitem>
-	  <para>
-	    If set, these environment variables will be assumed to
-	    contain the source device name and the target device
-	    mapper name, respectively, and will be shown as part of
-	    the prompt.
-	</para>
-	<para>
-	  These variables will normally be inherited from
-	  <citerefentry><refentrytitle>plugin-runner</refentrytitle>
-	  <manvolnum>8mandos</manvolnum></citerefentry>, which will
-	  normally have inherited them from
-	  <filename>/scripts/local-top/cryptroot</filename> in the
-	  initial <acronym>RAM</acronym> disk environment, which will
-	  have set them from parsing kernel arguments and
-	  <filename>/conf/conf.d/cryptroot</filename> (also in the
-	  initial RAM disk environment), which in turn will have been
-	  created when the initial RAM disk image was created by
-	  <filename
-	  >/usr/share/initramfs-tools/hooks/cryptroot</filename>, by
-	  extracting the information of the root file system from
-	  <filename >/etc/crypttab</filename>.
-	</para>
-	<para>
-	  This behavior is meant to exactly mirror the behavior of
-	  <command>askpass</command>, the default password prompter.
-	</para>
-	</listitem>
-      </varlistentry>
-    </variablelist>
-  </refsect1>
-  
-  <refsect1 id="files">
-    <title>FILES</title>
-    <variablelist>
-      <varlistentry>
-	<term><filename>/bin/plymouth</filename></term>
-	<listitem>
-	  <para>
-	    This is the command run to retrieve a password from
-	    <citerefentry><refentrytitle>plymouth</refentrytitle>
-	    <manvolnum>8</manvolnum></citerefentry>.
-	  </para>
-	</listitem>
-      </varlistentry>
-      <varlistentry>
-	<term><filename>/proc</filename></term>
-	<listitem>
-	  <para>
-	    To find the running <citerefentry><refentrytitle
-	    >plymouth</refentrytitle><manvolnum>8</manvolnum>
-	    </citerefentry>, this directory will be searched for
-	    numeric entries which will be assumed to be directories.
-	    In all those directories, the <filename>exe</filename> and
-	    <filename>cmdline</filename> entries will be used to
-	    determine the name of the running binary, effective user
-	    and group <abbrev>ID</abbrev>, and the command line
-	    arguments.  See <citerefentry><refentrytitle
-	    >proc</refentrytitle><manvolnum>5</manvolnum>
-	    </citerefentry>.
-	  </para>
-	</listitem>
-      </varlistentry>
-      <varlistentry>
-	<term><filename>/sbin/plymouthd</filename></term>
-	<listitem>
-	  <para>
-	    This is the name of the binary which will be searched for
-	    in the process list.  See <citerefentry><refentrytitle
-	    >plymouth</refentrytitle><manvolnum>8</manvolnum>
-	    </citerefentry>.
-	  </para>
-	</listitem>
-      </varlistentry>
-    </variablelist>
-  </refsect1>
-  
-  <refsect1 id="bugs">
-    <title>BUGS</title>
-    <para>
-      Killing the <citerefentry><refentrytitle
-      >plymouth</refentrytitle><manvolnum>8</manvolnum></citerefentry>
-      daemon and starting a new one is ugly, but necessary as long as
-      it does not support aborting a password request.
-    </para>
-  </refsect1>
-  
-  <refsect1 id="example">
-    <title>EXAMPLE</title>
-    <para>
-      Note that normally, this program will not be invoked directly,
-      but instead started by the Mandos <citerefentry><refentrytitle
-      >plugin-runner</refentrytitle><manvolnum>8mandos</manvolnum>
-      </citerefentry>.
-    </para>
-    <informalexample>
-      <para>
-	This program takes no options.
-      </para>
-      <para>
-	<userinput>&COMMANDNAME;</userinput>
-      </para>
-    </informalexample>
-  </refsect1>
-  
-  <refsect1 id="security">
-    <title>SECURITY</title>
-    <para>
-      If this program is killed by a signal, it will kill the process
-      <abbrev>ID</abbrev> which at the start of this program was
-      determined to run <citerefentry><refentrytitle
-      >plymouth</refentrytitle><manvolnum>8</manvolnum></citerefentry>
-      as root (see also <xref linkend="files"/>).  There is a very
-      slight risk that, in the time between those events, that process
-      <abbrev>ID</abbrev> was freed and then taken up by another
-      process; the wrong process would then be killed.  Now, this
-      program can only be killed by the user who started it; see
-      <citerefentry><refentrytitle>plugin-runner</refentrytitle>
-      <manvolnum>8mandos</manvolnum></citerefentry>.  This program
-      should therefore be started by a completely separate
-      non-privileged user, and no other programs should be allowed to
-      run as that special user.  This means that it is not recommended
-      to use the user "nobody" to start this program, as other
-      possibly less trusted programs could be running as "nobody", and
-      they would then be able to kill this program, triggering the
-      killing of the process <abbrev>ID</abbrev> which may or may not
-      be <citerefentry><refentrytitle>plymouth</refentrytitle>
-      <manvolnum>8</manvolnum></citerefentry>.
-    </para>
-    <para>
-      The only other thing that could be considered worthy of note is
-      this:  This program is meant to be run by <citerefentry>
-      <refentrytitle>plugin-runner</refentrytitle><manvolnum
-      >8mandos</manvolnum></citerefentry>, and will, when run
-      standalone, outside, in a normal environment, immediately output
-      on its standard output any presumably secret password it just
-      received.  Therefore, when running this program standalone
-      (which should never normally be done), take care not to type in
-      any real secret password by force of habit, since it would then
-      immediately be shown as output.
-    </para>
-  </refsect1>
-  
-  <refsect1 id="see_also">
-    <title>SEE ALSO</title>
-    <para>
-      <citerefentry><refentrytitle>crypttab</refentrytitle>
-      <manvolnum>5</manvolnum></citerefentry>,
-      <citerefentry><refentrytitle>plugin-runner</refentrytitle>
-      <manvolnum>8mandos</manvolnum></citerefentry>,
-      <citerefentry><refentrytitle>proc</refentrytitle>
-      <manvolnum>5</manvolnum></citerefentry>,
-      <citerefentry><refentrytitle>plymouth</refentrytitle>
-      <manvolnum>8</manvolnum></citerefentry>
-    </para>
-  </refsect1>
-</refentry>
-<!-- Local Variables: -->
-<!-- time-stamp-start: "<!ENTITY TIMESTAMP [\"']" -->
-<!-- time-stamp-end: "[\"']>" -->
-<!-- time-stamp-format: "%:y-%02m-%02d" -->
-<!-- End: -->

=== modified file 'plugins.d/splashy.c'
--- plugins.d/splashy.c	2010-09-26 18:32:58 +0000
+++ plugins.d/splashy.c	2010-09-07 16:48:58 +0000
@@ -2,8 +2,8 @@
 /*
  * Splashy - Read a password from splashy and output it
  * 
- * Copyright © 2008-2010 Teddy Hogeborn
- * Copyright © 2008-2010 Björn Påhlsson
+ * Copyright © 2008,2009 Teddy Hogeborn
+ * Copyright © 2008,2009 Björn Påhlsson
  * 
  * This program is free software: you can redistribute it and/or
  * modify it under the terms of the GNU General Public License as

=== modified file 'plugins.d/usplash.c'
--- plugins.d/usplash.c	2010-09-26 18:32:58 +0000
+++ plugins.d/usplash.c	2010-09-15 17:21:04 +0000
@@ -2,8 +2,8 @@
 /*
  * Usplash - Read a password from usplash and output it
  * 
- * Copyright © 2008-2010 Teddy Hogeborn
- * Copyright © 2008-2010 Björn Påhlsson
+ * Copyright © 2008,2009 Teddy Hogeborn
+ * Copyright © 2008,2009 Björn Påhlsson
  * 
  * This program is free software: you can redistribute it and/or
  * modify it under the terms of the GNU General Public License as

